#include "button.h"
#include "Arduino.h"

Button::Button() {
    // no-op
}

Button::Button(int port) {
    pinMode(port, INPUT);
    this->port = port;
}

bool Button::is_pressed() const {
    return pressed;
}

bool Button::is_triggered() const {
    return triggered;
}

void Button::update() {
    triggered = false;

    if (digitalRead(port) == HIGH) {
        if (pressed) {}
        else if (!last_state) {
            last_state = true;
        } else {
            pressed = true;
            triggered = true;
            last_state = false;
        }
    } else {
        last_state = false;
        pressed = false;
    }
}
