# Praktikum 11: 2D-Grafik auf dem Arduino

Heute werden wir das OLED-Display SSD1306 ansteuern. Im Gegensatz zu dem LCD-Display kann hier jeder Pixel einzeln angesteuert werden, wodurch es viel flexibler ist.

![](Images/SSD1306.jpg)

Das Ziel soll eine Animation wie bei dem DVD-Logo im DVD-Bildschirmschoner sein.

## Löt-Aufgabe für das Löt-Praktikum

An das OLED-Display müssen noch der Steckverbinder angelötet werden.

Dies werden Sie heute bei Frau Zimmer im Löt-Praktikum machen.

Löten Sie bitte den Verbinder nach hinten an, damit das Display auf ein Breadboard gesteckt werden kann (siehe Abbildung).

![](Images/Lot.jpg)

## Aufgabe 1: Display-Test

Zuerst werden wir testen, ob das Display funktionsfähig ist.

_Achtung_: Da das OLED-Display noch nicht gelötet ist, kann jede Bewegung zum Absturz führen. Fassen Sie das Display also möglichst nicht mehr an, sobald es einmal funktioniert. Sie müssen es eventuell mehrmals probieren, bis es funktioniert.

Laden Sie dazu das Projekt ``p11_display_test``, diese ist bereits in ``platformio.ini`` so konfiguriert, dass die Display-Bibliothek verfügbar ist. Als Bibliothek werden wir Adafruit verwenden. Dies ist eine objektorientierte Bibliothek zur Ansteuerung des Displays und bietet auch bereits einige Zeichenfunktionen.

Wie das Display _low level_ angesteuert werden kann, werden wir nicht behandeln, da man dazu zuerst das I2C Bus-Protokoll verstehen muss und das thematisch zu weit.

Machen Sie folgenden Aufbau und flashen Sie dann das Projekt. Sie müssten _Hallo Welt_, einen Zähler und ein wanderndes Rechteck sehen.

Falls Sie nichts auf dem Display sehen, überprüfen Sie auch den Zustand der LED: Beim Start ist diese ca. 1 Sekunde an, danach sollte diese pulsieren. Wichtig ist auch ``SDA`` und ``SCL`` nicht zu verwechseln! Wackeln Sie nun ein bisschen am Display und drücken Sie Reset, irgendwann gehts.

![](Images/OLED_Steckplatine.svg)

## Aufgabe 2: DVD-Logo

### Aufgabe 2.1: Kennenlernen

Laden Sie nun das eigentliche Projekt (``p11_code_arduino``).

Machen Sie sich mit dem Projekt vertraut. Es basiert auf dem von _Vorlesung 11_.

Schauen Sie sich an, was für Methoden die Klasse ``Adafruit_SSD1306`` über ihre Instanz ``display`` anbietet und spielen Sie damit ein wenig herum.

Setzen Sie dann die folgenden Aufgaben um:

1. Ändern Sie den Radius des Kreises auf ``10`` und die Startkoordinaten auf ``20, 25``.
2. Zeichnen Sie ein Rechteck mit beliebigen Maßen. Das Rechteck soll den Kreis teilweise überlappen.
3. Zeichen Sie an den folgenden Koordinaten Pixel: ``[(50, 50), (52, 50), (51, 51), (50, 52), (52, 52)]``. Was kommt dabei heraus?
4. Probieren Sie ``display.invertDisplay(true)`` aus :)

### Aufgabe 2.2: Animiertes Logo

Der Kreis soll sich nun bewegen und wie das DVD-Logo an den Rändern abprallen.

_Wie das geht, werden wir gemeinsam machen_

### Aufgabe 2.3: Zusätzliche Spielereien

Fügen Sie noch zwei Taster und ein Potentiometer hinzu:

![](Images/OLED2_Steckplatine.svg)

Führen Sie nun die folgenden Funktionalitäten ein:

1. Der 1. Taster kehrt bei Tastendruck die X-Komponente des Kreises um
2. Der 2. Taster kehrt bei Tastendruck die Y-Komponente des Kreises um
3. Das Potentiometer soll die Geschwindigkeit regulieren. Bei ``0V`` soll der Kreis stillstehen und bei ``5V`` mit ``10px`` pro Frame wandern. Die Zwischenstufen sollen linear interpoliert werden.
