#include "circle.h"
#include "point.h"

Circle::Circle() {
    radius = 1.0;
    top_left = Point(-1, -1);
}

Circle::Circle(Point top_left, double radius) {
    this->top_left = top_left;
    set_radius(radius);
}

double Circle::get_radius() const {
    return radius;
}

void Circle::set_radius(double radius) {
    this->radius = radius;
}

double Circle::get_diameter() const {
    return 2 * radius;
}

Point Circle::get_center() const {
    Point mittelpunkt(
        top_left.x + radius,
        top_left.y + radius
    );

    return mittelpunkt;
}

bool Circle::is_inside(const Point& p) const {
    Point mittelpunkt = get_center();

    return (mittelpunkt.distance_to(p) < radius);
}
