/**
 * Display-Testprogramm.
 * Nach dem Flashen Arduino resetten.
 * Led standardmäßig an Port 2
 */

#include <Arduino.h>
#include <ArduinoSTL.h>

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#include "led.h"

/** Hier können globale Variablen definiert werden. */
const int width = 128;
const int height = 64;
Adafruit_SSD1306 display(width, height);

Led test_led;

void setup() {
    Serial.begin(9600);

    test_led = Led(2);
    test_led.on();

    // Display initialisieren
    if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
        std::cout << "SSD1306 fehler!\n";
    }

    delay(1000);
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.print("Hallo Welt!");
    display.display();

    test_led.off();
}

void loop() {
    static int counter = 0;

    test_led.pulse();

    display.clearDisplay();
    display.setCursor(0, 10);

    ++counter;
    display.println(counter);

    static int x_off = 0;
    static int y_off = 0;

    for (int x = 0; x < 16; ++x) {
        for (int y = 0; y < 16; ++y) {
            display.drawPixel(x + x_off, y + y_off, 1);
        }
    }

    ++x_off;
    ++y_off;

    x_off = x_off % 128;
    y_off = y_off % 64;

    display.display();
}
