#pragma once

#include "sprite.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    int item_at(int row, int col) const;

    int count_neighbours(int row, int col) const;

    void update_field();

    void draw(Adafruit_SSD1306& display) override;

    /** Anzahl Zellen je Zeile */
    const uint8_t field_width = 128 / 4;

    /** Anzahl Zellen je Spalte */
    const uint8_t field_height = 64 / 4;

    /** Breite und Höhe einer Zelle in Pixeln */
    const uint8_t rect_dim = 4;

private:
    /** Spielfeld (0 = tot, 1 = lebendig) */
    std::vector<std::vector<uint8_t>> field;
};
