#include <Arduino.h>
#include <ArduinoSTL.h>

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#include "button.h"
#include "circle.h"
#include "led.h"
#include "board.h"

/** Hier können globale Variablen definiert werden. */
const int width = 128;
const int height = 64;
Adafruit_SSD1306 display(width, height);

Led rot;
Board board;

/** Wird nach der Hardware-Initialisierung einmalig aufgerufen */
void setup() {
    // Konsolenausgabe aktivieren
    Serial.begin(9600);

    rot = Led(2);
    rot.on();

    // Display initialisieren
    if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
        std::cout << "SSD1306 fehler!\n";
    }

    delay(1000);
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.print("Hallo Welt!");
    display.display();

    rot.off();
}

/** Wird in einer Endlosschleife aufgerufen */
void loop() {
    rot.pulse();

    display.clearDisplay();

    board.update_field();
    board.draw(display);

    display.display();
}
