#include <Arduino.h>
#include <ArduinoSTL.h>

#include "led.h"
#include "button.h"

/** Hier können globale Variablen definiert werden. */
int counter = 0;
bool led_mode = false;
std::vector<Led> leds;
Button pulse_button;
Button light_switch;

/** Wird nach der Hardware-Initialisierung einmalig aufgerufen */
void setup() {
    // Konsolenausgabe aktivieren
    Serial.begin(9600);

    std::cout << "Hallo Welt!\n";

    leds.push_back(Led(3));
    leds.push_back(Led(4));
    leds.push_back(Led(5));
    leds.push_back(Led(6));
    leds.push_back(Led(7));

    for (auto& led: leds) {
        led.on();
    }

    pulse_button = Button(2);
    light_switch = Button(3);
}

/** Wird in einer Endlosschleife aufgerufen */
void loop() {
    if (counter <= 10) {
        leds[0].on();
    } else {
        leds[0].off();
    }

    if (counter > 10 && counter <= 20) {
        leds[1].on();
    } else {
        leds[1].off();
    }

    if (counter > 20 && counter <= 30) {
        leds[2].on();
    } else {
        leds[2].off();
    }

    pulse_button.update();
    light_switch.update();

    if (pulse_button.is_pressed()) {
        leds[3].pulse();
    }

    if (light_switch.is_triggered()) {
        led_mode = !led_mode;
    }

    if (led_mode) {
        leds[4].on();
    } else {
        leds[4].off();
    }

    // Der counter zählt, wie oft die Schleife durchlaufen wurde
    // Kann für Timings verwendet werden
    ++counter;

    if (counter > 30) {
        counter = 0;
    }
}
