/*********
  Rui Santos
  Complete project details at https://randomnerdtutorials.com
*********/

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <ArduinoSTL.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

void setup() {
  Serial.begin(9600);

  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println("SSD1306 allocation failed");
    for(;;);
  }
  delay(2000);
  display.clearDisplay();

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  // Display static text
  display.println("Hello, world!");
  display.display();
}

void loop() {
  std::cout << "Hello\n" << "\n";
  //delay(5);
  display.clearDisplay();

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);

static int i = 0;
  ++i;
  display.println(i);
  //display.println("Hello, world!");

  static int x_off = 0;
  static int y_off = 0;

  //display.drawRect(x_off, y_off, 16, 16, 1);

  for (int x = 0; x < 16; ++x) {
    for (int y = 0; y < 16; ++y) {
     display.drawPixel(x + x_off, y + y_off, 1);
    }
  }

  ++x_off;
  ++y_off;

  x_off = x_off % 128;
  y_off = y_off % 64;

  // Display static text
  display.display();
}
