# Ein Projekt laden

Entpacken Sie ``p01_code.zip`` und öffnen Sie den Ordner dann in Visual Studio Code.

**Wichtig:** Der Pfad zum Quelltext darf keine Leerzeichen oder Sonderzeichen (Umlaute etc.) enthalten. Dies verursacht viele Probleme.

Gehen Sie auf "Datei -> Ordner öffnen" (File -> Open Folder).

Passen Sie hier unbedingt auf, dass Sie den richtigen Ordner erwischen. Es muss der Ordner sein, wo die ``CMakeLists.txt`` drinnen liegt. Also kein Ordner, der eine Stufe höher ist, sonst funktioniert es nicht.

Beim Öffnen des Projekts kommt eine Warnung. Klicken Sie hier auf "Ja, ich vertraue den Autoren" (Yes, I trust the authors).

![](Images/VsCode5.png)

## Notwendige Konfiguration bei jedem Projekt

VS Code möchte nun, dass Sie ein "Kit" konfigurieren. Unter in der blauen Leiste steht "Kein Kit konfiguriert" (No Kit selected).

![](Images/VsCode8.png)

Klicken Sie darauf und wählen Sie "Visual Studio 2022 amd64" (Windows) bzw. "[Unspecified]" (alle anderen Systeme) aus.

![](Images/VsCode9.png)

Eventuell werden Sie jetzt gefragt, ob Sie das Projekt konfigurieren möchten. Bestätigen Sie diese Meldung. Falls die Meldung nicht kommt, klicken Sie in der blauen Leiste auf "CMake" und dann in der Leiste oben auf "Debug".

## Meldungen, wenn Sie die allererste C++-Datei öffnen

Gehen Sie oben links auf das erste Symbol (Explorer).

Gehen Sie auf ``src`` und dann auf ``main.cpp``.

Wenn Sie zum allerersten Mal eine cpp-Datei öffnen, bekommen Sie einige Meldungen unten rechts angezeigt.

Bei "You have both the Microsoft C++..." klicken Sie auf "Disable IntelliSense"

![](Images/VsCode6.png)

Bei "The clangd language server" klicken Sie auf "Install"

![](Images/VsCode7.png)

Zudem werden Sie noch gefragt, ob Sie die empfohlenen Erweiterungen installieren möchten (C/C++ Extension Pack). Diesen Dialog können Sie schließen. Das benötigen wir nicht.

## Ein Programm ausführen

Sie haben es geschafft!

Drücken Sie F5, um das Programm zu kompilieren und zu starten.

Falls Sie an einem Laptop arbeiten und nichts passiert, sind die F-Tasten die Zweitbelegung auf der Tastatur. Sie müssen dann FN (links unten neben STRG) gedrückt halten und dann F5 drücken. Dies ist ziemlich nervige Fingerakkrobatik.  Falls Sie das stört: Bei macOS lässt sich das Verhalten in den Systemeinstellungen bei "Tastatur" ändern. Bei Windows kommt es auf das Gerät an: Manche Tastaturen haben eine FN-Lock-Funktion um das direkt umzuschalten. Bei anderen können Sie das Verhalten nur in der Firmware ändern (siehe unten bei _Problembehandlung_).

Folgen Sie den Anweisungen im Konsolenfenster.

Alles weitere besprechen wir dann in Vorlesung und späteren Praktika.

![](Images/VsCode10.png)

## Problembehandlung: Die Umlaute sehen im Konsolenfenster komisch aus (Windows)

Das beheben wir in einem späteren Praktikum.

Die falsche Darstellung der Zeichen hat historische Gründe (Windows verwendet kein Unicode in der Konsole).

## Problembehandlung: Debugger funktioniert nicht (macOS)

1. Drücken Sie "Command + Shift + p"
2. Geben Sie "Tasks" ein
3. Wählen Sie "macOS: Terminalrechte anfordern"
4. Bestätigen Sie die Warnung. Nun sollte das Debuggen mit F5 funktionieren

Letztes Jahr machte der Debugger generell auf M1 (ARM) Systemen Probleme. Ich kann nicht sagen, ob das schon gelöst wurde.

## Problembehandlung: UEFI-Firmware betreten & FN-Lock umschalten (Windows)

Das Verhalten von FN lässt sich bei einigen Laptops in der Firmware ändern.

Wenn Sie ein Lenovo-Gerät verwenden: Dort kann man auch STRG und FN vertauschen. Bei Lenovo ist die FN-Taste unten links, was dazu führt, dass man ständig FN anstatt STRG drückt, wenn man andere Tastaturen gewöhnt ist. Totaler Blödsinn...

1. Halten Sie die linke Umschalttaste gedrückt und klicken Sie im Startmneü auf "Neu Starten"
2. Es erscheint "Einen Moment Bitte"
3. Sie wählen Problembehandlung -> Erweiterte Optionen -> UEFI Firmware Starten

Falls diese Option nicht existiert:

1. Starten Sie Ihren Computer neu und drücken Sie mehrmals die ENTF-Taste sobald das Hersteller-Logo erscheint.
2. Falls dies nicht funktioniert probieren Sie mehrmals schnell ESC oder F2.

Wo Sie die FN-Taste umstellen ist leider herstellerabhängig. Schauen Sie am Besten in das Handbuch oder Fragen Sie das Internet.

Verlassen Sie im Anschluss die Firmware mittels Exit -> Save and Exit.
