## Praktikum 2

Da wir inhaltlich noch nicht allzu weit vorangeschritten sind, dient dieses Praktikum dazu, sich mit der Entwicklungsumgebung (IDE) und grundlegenden C++-Konzepten vertraut zu machen.

Bisher haben wir die folgenden Themen behandelt:

- Textein-/ausgabe
- Debugger bedienen
- Arten von Zahlen (Datentypen)
- Bedingungen

_Hinweis: Falls Ihnen die Befehle nicht mehr einfallen schauen Sie sich die Storyteller bei V01 an_

### Aufgabe 1: Hallo Welt

Entpacken Sie das Projekt-Archiv des Praktikums in einen Ordner. Öffnen Sie den Projekt-Ordner in Visual Studio Code mit "Datei -> Order öffnen". Beachten Sie, dass Sie den Ordner mit der ``CMakeLists.txt`` öffnen müssen, sonst funktioniert es nicht.

Sie finden eine C++-Quelltextdatei names ``aufgabe1.cpp`` im Ordner ``src``. Mit dieser Datei sollen Sie in dieser Aufgabe arbeiten.

Als erste Aufgabe sollen Sie den Nutzer befragen.

Erfragen Sie auf der Konsole vom Benutzer die folgenden Dinge und speichern Sie es dann in Variablen mit geeignetem Datentyp ab. Wissen Sie noch, wie die verschiedenen Datentypen in C++ hießen? Erinnern Sie sich noch, wie auf der Konsole ein Zeilenumbruch ging?

- Die Lieblingsfarbe
- Das Alter der Person
- Die Größe in Metern (m)

Geben Sie es im Anschluss folgende Details geeignet auf der Konsole aus:

- Die Lieblingsfarbe
- Das Geburtsjahr unter der Annahme, dass die Person in diesem Jahr Geburtstag hatte
- Die Größe in cm

### Aufgabe 2: Gehaltsrechner

Erstellen Sie für jede der Aufgaben eine neue C++-Datei und fügen Sie diese als neue Anwendung zu der ``CMakeLists.txt`` hinzu:

```cmake
add_executable(name_der_anwendung
	src/name_der_anwendung.cpp
)
```

Ersetzen Sie ``name_der_anwendung.cpp`` mit etwas geeignetem, z.B. ``aufgabe02``. Denken Sie auch daran das Startprojekt auf ``aufgabe2`` zu ändern. Das Startprojekt können Sie in der linken Symbolleiste unter CMake ändern. Der Eintrag sieht am Ende also beispielsweise folgendermaßen aus:

```cmake
add_executable(aufgabe02
	src/aufgabe02.cpp
)
```

Sie erstellen hier einen einfachen Gehaltsrechner.

1. Fragen Sie zuerst den Benutzer, ob er seinen Stundenlohn oder das monatliche Gehalt eingeben möchte. Welche Eingabe Sie hier erwarten, ist Ihnen freigestellt. Beispielsweise könnte "0" für "Stundenlohn" und "1" für "Monatsgehalt" stehen. Geben Sie bei einer ungültigen Eingabe eine Fehlermeldung aus brechen Sie das Programm frühzeitig mit ``return`` ab.
2. Wenn der Benutzer "Stundenlohn" gewählt hat, fragen Sie Ihn zusätzlich auch nach seiner wöchentlichen Arbeitszeit.
3. Geben Sie nun das Jahresgehalt des Benutzers aus. Wir gehen davon aus, dass ein Monat 4 Wochen und ein Jahr 12 Monate hat. Es gibt also keine Boni, 13. Gehalt etc.

### Aufgabe 3: Taschenrechner

Fügen Sie zunächst der ``CMakeLists.txt`` wieder einen neuen Eintrag hinzu:

```cmake
add_executable(aufgabe03
	src/aufgabe03.cpp
)
```

Programmieren Sie einen einfachen Taschenrechner. Fragen Sie dazu vom Benutzer ab:

- Zwei Zahlen
- Den Operator der Rechenoperation (``+``, ``-``, ``*``, ``/`` oder ``%``)

Führen Sie nun ausgehend von der Benutzereingabe die Berechnung durch und geben Sie das Ergebnis auf der Konsole aus.

## Aufgabe 4: Der Debugger

Der Debugger ist ein mächtiges Werkzeug um Fehler im Programm zu untersuchen.

Lesen Sie sich auf Moodle "Debuggen mit Visual Studio Code" durch und probieren Sie den Debugger in einer Ihrer vorherigen Aufgaben aus.
