# Praktikum 4

Die letzte Vorlesung handelte von Projektstrukturierung.

Daher arbeiten wir heute mit einer größeren Anwendung, die aus mehreren cpp- und h-Dateien besteht.

Das Grundgerüst finden Sie wie immer im Quellcode-Archiv.

Zur Erinnerung:

- Vergessen Sie nicht die Include-Guards (``#pragma once``)
- Für eigene Dateien verwendet man beim Include übrigens ``""``, also z.B. ``#include "mein_code.h"``. Die spitzen Klammern ``<>`` sind den Systemheadern vorbehalten.
- Schreiben Sie im Header Dokumentationskommentare (Javadoc)

**Gehen Sie Schritt für Schritt vor**

## Aufgabe 1

Öffnen Sie den Ordner ``aufgabe1`` in Visual Studio Code.

Das Projekt besteht bereits aus mehreren Dateien:

- ``main.cpp``: Hier befindet sich die ``main``, also der Start des Programms. Zudem ist hier bereits beispielhaft dargestellt, wie man einen weiteren Header (``mein_code.h``) einbindet und die ``add``-Funktion aus diesem Header verwendet.
- ``mein_code.h``: Dieser Header definiert die zwei Funktionen ``add`` (mit zwei bzw. drei Parametern)
- ``mein_code.cpp``: Hier ist die Implementierung der zwei ``add``-Funktionen
- ``CMakeLists.txt``: Die Projektbeschreibung. Schauen Sie nach, wie ``mein_code.cpp`` hier eingebunden wurde (der Header kann hier weggelassen werden).

### Aufgabe 1.1

Ähnlich zu ``mein_code.cpp/.h`` erstellen Sie nun ``calc.cpp/.h``:

1. Erstellen Sie im Ordner ``src`` die Dateien ``calc.cpp`` und ``calc.h``.
2. Fügen Sie in der ``calc.h`` den Header-Guard ein.
3. Fügen Sie in der ``calc.cpp`` den Include ein.
4. Fügen Sie den Include auch in die ``main.cpp`` ein, damit die Funktionen nachher verwendet werden können
5. Fügen Sie ``calc.cpp`` an geeigneter Stelle der ``CMakeLists.txt`` hinzu.

### Aufgabe 1.2

Implementieren Sie in ``calc.cpp/.h`` die Funktion ``int maximum(int zahl, int zahl2)``. Orientieren Sie sich an ``add`` aus ``mein_code.cpp/.h``.

Diese Funktion akzeptiert zwei Zahlen als Parameter und gibt dann die größere von beiden Zahlen zurück.

Schreiben Sie auch einen Dokumentationskommentar und rufen Sie die Funktion (in ``main``) testweise mit verschiedenen Parametern auf, um die korrekte Funktionalität sicherzustellen.

### Aufgabe 1.3

Implementieren Sie in ``calc.cpp/.h`` die Funktion ``int clamp(int zahl, int links, int rechts)``.

Diese Funktion stellt sicher, dass eine übergebene ``zahl`` in einem Intervall, beschrieben durch ``links`` und ``rechts``, liegt.

Wenn die ``zahl`` im Intervall liegt, soll die Zahl selbst zurückgegeben werden.

Ansonsten soll das Intervall zurückgegeben werden, dass der Zahl am nächsten ist.

### Aufgabe 1.4

Erzeugen Sie ähnlich wie in Aufgabe 1.1 die Dateien ``rechner.cpp`` und ``rechner.h``.

### Aufgabe 1.5: Stapelspeicher

Wir sprachen in einer der vorherigen Vorlesungen über die umgekehrte polnische Notation.

Diese wird verwendet, um Terme ohne Klammern zu schreiben und kann mit einem _Stack_ implementiert werden.

#### Beispiel

Der Term ``(4 + 3) * (2 + 1)`` entspricht ``4 3 + 2 1 + *``.

Die Zahlen werden dabei von links nach rechts auf einem Stapel (oder ``vector``) abgelegt.

Wenn ein Operator auftritt, nimmt dieser die letzten zwei Elemente vom Stapel und legt das Ergebnis auf den Stapel.

Hier schrittweise der Stapel für den Term oben:

1. ``[4]``
2. ``[4, 3]``
3. ``[7]`` (Ergebnis von ``+``)
4. ``[7, 2]``
5. ``[7, 2, 1]``
6. ``[7, 3]`` (Ergebnis von ``+``)
7. ``[21]`` (Ergebnis von ``*``)
8. Das Rechenergebnis steht nun als einziges Element auf dem Stapel

#### Ihre Aufgabe

Schreiben Sie in ``rechner.cpp/.h`` eine Funktion ``int rechner(const std::string& term)``, welche einen Rechenterm als Parameter erhält.

Der Einfachheit halber sind alle Zahlen positiv und einstellig. Der Term von oben wäre also ``43+21+*``.

Implementieren Sie nun diesen Rechner unter Verwendung eines ``std::vector<int>`` als Stapel.

Wenn der Term durchlaufen ist, geben Sie das letzte Element auf dem Stapel als Ergebnis zurück.

Es sollen mindestens die Operatoren ``+``, ``-`` und ``*`` unterstützt werden.

Hinweis: Um eine ASCII-Ziffer in eine richtige Ziffer umzuwandeln, verwenden Sie: ``int num = zeichen - '0'``;

## Aufgabe 2

**Diese Aufgabe ist im Selbststudium zu lösen**

Öffnen Sie den Ordner ``aufgabe2`` in Visual Studio Code.

Wir programmieren nun Stein, Schere, Papier.

Wer die Regeln nicht kennt:

- Es wird von zwei Spielern gespielt (bzw. hier: Ein Spieler gegen den Computer)
- Beide Spieler zeigen gleichzeitig via Handgeste eine der drei Möglichkeiten von oben (in unserem Fall wird der Spieler gefragt und der Computer erzeugt sein Zeichen zufällig)
- Stein besiegt Schere, Schere besiegt Papier, Papier besiegt Stein

Wir ordnen den Symbolen Zahlen zu. Um die Lesbarkeit zu erhöhen, verwenden wir dafür einen Aufzählungstyp (``enum``).

Wie das funktioniert ist in der ``main.cpp`` erläutert.

## Aufgabe 2.1

Im Projekt ist bereits ``zufall.cpp/.h`` gegeben (bekannt aus der Vorlesung).

Implementieren Sie dort nun eine Funktion ``int zug()``, welche eine zufällige Zahl im Bereich von 0 bis 2 zurückgibt.

Diese Funktion wird der Computergegner nachher für seinen Zug verwenden.

## Aufgabe 2.2

Fügen Sie der ``main.cpp`` eine neue Funktion ``std::string zahlwort(int zeichen)`` hinzu.

Diese soll zurückgeben:

- ``"Stein"`` für 0
- ``"Schere"`` für 1
- ``"Papier"`` für 2

## Aufgabe 2.3

Nun kann das Spiel in der ``main`` umgesetzt werden.

Der Spieler wird nach einer Zahl von 0 bis 2 gefragt (oder nach einem String, können Sie frei entscheiden).

Der Computer verwendet ``zug()``, um sein Symbol zu ermitteln.

Jetzt wird anhand des Symbols geprüft, wer gewonnen hat, bzw. unentschieden (gleiches Symbol bei beiden) ausgegeben.

Über die Textausgabe sollte der Spielablauf ersichtlich sein.
