#include <iostream>
#include "zufall.h"

// Mit enum werden zusammengehörige Dinge gruppiert
// Nur die erste Zahl muss angegeben werden (Standard ist 0), danach wird aufsteigend nummeriert
enum Symbole {
    Stein = 0,
    Schere,
    Papier
};

/*
Ist also äquivalent zu:
const int Stein = 0;
const int Schere = 1;
const int Papier = 2;
*/

std::string zahlwort(int zeichen) {
    if (zeichen == Stein) {
        return "Stein";
    } else if (zeichen == Schere) {
        return "Schere";
    } else if (zeichen == Papier) {
        return "Papier";
    } else {
        return "???";
    }
}

int main() {
    int spieler_zeichen;

    std::cout << "Wähle aus (1, 2 oder 3):\n";
    std::cout << "1 Stein\n";
    std::cout << "2 Schere\n";
    std::cout << "3 Papier\n";
    std::cin >> spieler_zeichen;

    spieler_zeichen -= 1; // Weil Aufzählung oben 0-basiert ist aber Eingabe 1-basiert

    int computer_zeichen = zug();

    std::cout << zahlwort(spieler_zeichen) << " vs. " << zahlwort(computer_zeichen) << "\n";

    if (spieler_zeichen == computer_zeichen) {
        std::cout << "Unentschieden!\n";
    } else if (
        (spieler_zeichen == Stein && computer_zeichen == Schere) ||
        (spieler_zeichen == Schere && computer_zeichen == Papier) ||
        (spieler_zeichen == Papier && computer_zeichen == Stein)) {

        std::cout << "Spieler gewinnt!\n";
    } else {
        std::cout << "Computer gewinnt!\n";
    }

    return 0;
}
