#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric> // für std::accumulate

int main() {
    std::vector<int> vec = {1, 3, -2, 5, -4, 6, -1, 8, 10};

    // 1. Aufgabe
    // Wandeln Sie alle negativen Zahlen in positive um
    // Option 1:
    for (int& v: vec) {
        v = abs(v); // oder: if (v < 0) v = -v;
    }

    // Option 2:
    std::transform(vec.begin(), vec.end(), vec.begin(), [](int zahl) {
        return abs(zahl);
    });

    // 2. Aufgabe
    // Zählen Sie, wie viele Zahlen größer als 5 sind
    int anz = std::count_if(vec.begin(), vec.end(), [](int zahl) {
        return zahl > 5;
    });

    // 3. Aufgabe
    // Löschen Sie alle geraden Zahlen
    auto loeschen_it = std::remove_if(vec.begin(), vec.end(), [](int zahl) {
        return zahl % 2 == 0;
    });

    vec.erase(loeschen_it, vec.end());

    // 4. Aufgabe
    // Bilden Sie die Summe über alle verbleibenden Zahlen
    // Option 1:
    int summe = 0;
    for (int zahl: vec) {
        summe += zahl;
    }

    // Option 2:
    summe = std::accumulate(vec.begin(), vec.end(), 0);


    std::cout << anz << "\n";
    std::cout << summe << "\n";

    return 0;
}
