# Praktikum 6

Bevor Sie die Aufgaben lösen werfen Sie immer zuerst einen Blick in die Textdateien.

Die Dateien sind alle im Ordner ``text``. Dieser Ordner muss also beim Pfad immer mit angegeben werden!

_Hinweis zum Pfad_: Programme haben ein _Arbeitsverzeichnis_. Von diesem aus werden alle relativen Pfade gebildet.
Wenn Sie Ihr Programm mit Visual Studio Code starten ist das Arbeitsverzeichnis der Ordner, wo ``CMakeLists.txt`` liegt.

Da jede Anwendung nur aus einer Datei besteht, gibt es diesmal wieder nur eine ``CMakelists.txt`` für alle Anwendungen und Sie müssen das Startprojekt auf die konkrete Aufgabe ändern.

## Aufgabe 1: Hallo Welt!

### Aufgabe 1.1

Öffnen Sie die Datei ``hallo.txt`` und lesen Sie dann mit ``std::getline`` die erste Zeile aus der Datei und geben Sie diese auf der Konsole aus.

### Aufgabe 1.2

Ergänzen Sie das Programm nun um die folgenden Bestandteile:

Geben Sie mittels einer Schleife auch die restlichen Zeilen aus der Datei auf der Konsole aus.

Als Schleife können Sie ein ähnliches Konstrukt wie in Vorlesung und Storyteller verwenden. ``std::getline`` gibt den Zustand des Streams zurück, d. h. die Funktion kann als Bedingung in einer ``while``-Schleife verwendet werden.

### Aufgabe 1.3

Die zu lesende Datei soll nun als Kommandozeilenparameter übergeben werden (siehe Storyteller 03).

Den Parameter können Sie in der ``.vscode/launch.json`` konfigurieren. Die Option dafür ist ``args``. Diese Option ist bereits so vorkonfiguriert, dass ``text/zahlen.txt`` übergeben wird.

Probieren Sie auch die anderen Textdateien aus.

## Aufgabe 2: Zahlen

### Aufgabe 2.1

Die Datei ``zahlen.txt`` enthält mehrere Zahlen.

Lesen Sie alle Zahlen in einen geeigneten ``std::vector`` ein und geben Sie dann auf der Konsole aus:

1. Die Summe
2. Das arithmetische Mittel (Durchschnitt, also Summe geteilt durch Anzahl)
3. Den Median (Alle Zahlen aufsteigend sortieren und dann das mittlere Element ermitteln)

### Aufgabe 2.2

Lösen Sie die vorherige Aufgabe, aber verwenden Sie diesmal die Datei ``zahlen2.txt``.

### Aufgabe 2.3

Schreiben Sie die Zahlenliste _absteigend sortiert_ in die Datei ``zahlen_sortiert``.

## Aufgabe 3: Hallo Statistik!

Kopieren Sie Ihre Lösung von Aufgabe 1 in Aufgabe 3 hinein und ergänzen Sie diese mit folgender Statistik:

Zählen Sie die Anzahl an Groß- und Kleinbuchstaben in der übergebenen Datei und geben Sie die Anzahl auf der Konsole aus. Andere Zeichen (Interpunktion und Leerraum) sollen nicht gezählt werden.

Hilfreiche Funktionen dafür sind ``isalpha``, ``isupper`` und ``islower`` aus dem Header ``<cctype>``.
Informieren Sie sich im Internet über diese drei Funktionen.

## Aufgabe 4: Rangliste (*)

Die Datei ``hiscore.txt`` enthält eine Rekordtabelle für ein Computerspiel.

Der Aufbau ist folgendermaßen:

- Zeile 1: Spielername
- Zeile 2: Punktzahl

Diese zwei Zeilen werden bis zum Dateiende wiederholt.
Die Datei ist bereits nach der Platzierung sortiert.

## Aufgabe 4.1

1. Geben Sie die Namen der ersten drei Spieler aus
2. Geben Sie die aufsummierte Gesamtpunktzahl aller Spieler aus

## Aufgabe 4.2

Formatieren Sie die Datei in eine CSV-Datei um. Die Zieldatei soll ``hiscore.csv`` heißen.

In der ersten Zeilen soll der Header (``name,punkte``) stehen und anschließend folgt zeilenweise die Rangliste. Siehe dazu auch die Beispiel-Ausgabe.

### Beispiel

Eingabe (aus ``hiscore.txt``)

```
Sarah
7100
Gabriel
6980
Tina
6600
```

Ausgabe (nach ``hiscore.csv``):

```
name,punkte
Sarah,7100
Gabriel,6980
Tina,6600
```
