#include <cctype>
#include <fstream>
#include <iostream>
#include <string>
#include <cstring> // für strerror
#include <algorithm>

// Hier die Lösung für Aufgabe 1.3
int main(int argc, char** argv) {
    // Die Fehlerbehandlung war in der Aufgabe nicht explizit gefordert
    if (argc <= 1) {
        std::cerr << "Zu wenig Argumente!\n";
        return 1;
    }

    std::ifstream in(argv[1]);
    if (!in) {
        // Fehlerbehandlung
        std::cerr << "Fehler: " << strerror(errno) << "\n";
        return 1;
    }

    std::string zeile;
    int upper_v1 = 0;
    int lower_v1 = 0;
    int upper_v2 = 0;
    int lower_v2 = 0;
    while (std::getline(in, zeile)) {
        std::cout << zeile << "\n";

        // Variante 1: Schleife
        for (char ch: zeile) {
            if (isalpha(ch)) {
                if (std::isupper(ch)) {
                    ++upper_v1;
                } else if (std::islower(ch)) {
                    ++lower_v1;
                }
            }
        }

        // Variante 2: Algorithm
        auto it = std::remove_if(zeile.begin(), zeile.end(), [](char c) {
            return !isalpha(c);
        });
        zeile.erase(it, zeile.end());
        // Anstatt einer Lambdafunktion übergebe ich hier direkt die Funktionen,
        // da die Signatur passt
        upper_v2 += std::count_if(zeile.begin(), zeile.end(), isupper);
        lower_v2 += std::count_if(zeile.begin(), zeile.end(), islower);
    }

    std::cout << "Kleinbuchstaben: " << lower_v1 << "\n";
    std::cout << "Großbuchstaben: " << upper_v1 << "\n";

    std::cout << "Kleinbuchstaben: " << lower_v2 << "\n";
    std::cout << "Großbuchstaben: " << upper_v2 << "\n";

    return 0;
}
