# Praktikum 8: Objektorientierte Programmierung

Setzen Sie die gegebenen UML-Diagramme um.

## Punkt

### UML-Klassendiagramm

![](Point.png)

### Aufgaben

Zur Darstellung der Punkte der zweidimensionalen Ebene entwickeln Sie eine Klasse ``Point``.

Ein Punkt wird durch eine X- und eine Y-Koordinate beschrieben.

Das Grundgerüst der Klasse ist bereits im Quellcode-Archiv gegeben (siehe Dateien ``point.cpp/.h``).

### Beschreibung

Der ``Point`` verfügt über zwei ``private`` Felder ``x`` und ``y``. Diese enthalten die Koordinate des Punktes.

Zum Erzeugen von ``Point``-Objekten sollen zwei Konstruktoren bereitgestellt werden:

1. Der erste Konstruktor ist parameterlos und erzeugt den Punkt im Koordinatenursprung
2. Der zweite Konstruktor erzeugt den Punkt an den übergebenen Koordinaten.

Zwei Zugriffsmethoden (Getter) namens ``get_x`` und ``get_y`` sollen die Koordinatenwerte des Punktes zurückgeben.

Es gibt keine Setter, da die Verschiebung über die ``move``-Methoden erfolgten soll.

Durch zwei weitere Methoden sollen sich Punkte versetzen bzw. verschieben lassen:

- ``move_by`` verschiebt den Punkt, dazu werden die übergebenen Werte auf die Punktkoordinaten addiert
- ``move_to`` setzt die Koordinatenwerte des Punktes auf die übergebenen Koordinaten.

## Rechteck

### UML-Klassendiagramm

![](Rectangle.png)

![](Skizze.png)

### Aufgaben

Zur Darstellung eines Rechtecks erstellen Sie eine Klasse ``Rectangle``.

Unser Rechteck wird beschrieben durch:

- Den Punkt in der oberen, linken Ecke (``top_left``), Klasse ``Point``
- Breite (``width``) und Höhe (``height``) als Gleitkommazahl

Unser Rechteck ist also Achsenparallel.

Zuerst müssen Sie die Dateien ``rectangle.cpp/.h`` erstellen und dort das Grundgerüst der Klasse erzeugen. Im Gegensatz zur vorherigen Aufgabe ist dieses diesmal nicht gegeben.

### Beschreibung

Erzeugen Sie zuerst die drei Felder ``top_left``, ``width`` und ``height``. Diese sind diesmal ``public``.

Das Rechteck soll mit einem Konstruktor ausgestattet werden: Diesem werden der Eckpunkt, die Breite und die Höhe übergeben.

Für Rechtecke sollen folgende Methoden vorhanden sein:

- ``calc_area`` berechnet den Flächeninhalt und gibt ihn zurück.
- ``calc_circumference`` berechnet den Umfang und gibt ihn zurück.
- Methoden zur Verschiebung des Rechtecks sind nicht notwendig, da diese bereits von ``Point`` bereitgestellt werden.

## Zusatzaufgaben (*)

Für ``Point``: Die Methode ``void mirror(bool flip_x, bool flip_y)`` soll den Punkt spiegeln. Wenn ``flip_x`` wahr ist, soll die X-Koordinate an der x-Achse gespiegelt werden. Wenn ``flip_y`` wahr ist, soll die Y-Koordinate an der y-Achse gespiegelt werden.

Für ``Rectangle``: Die Methode ``bool collides_with(const Rectangle& other) const`` soll prüfen, ob zwei Rechtecke sich berühren.
