# Praktikum 9

## Aufgabe 1: Klasse ``Circle``

![](UML.png)

Programmieren Sie das abgebildete UML-Diagramm nach. Verwenden Sie für den Quelltext des Kreises die gleichnamige Datei ``circle.cpp/.h``. Ein Kreis wird durch dessen Ursprungspunkt (``top_left``) und dessen Radius (``radius``) beschrieben. Aus Konsistenzgründen mit anderen geometrischen Objekten, ist der Ursprungspunkt dabei oben links in der Ecke und nicht in der Mitte (siehe Abbildung).

![Ein Einheitskreis (Radius = 1) mit Ursprungspunkt (``top_left``) im Koordinatenursprung](Geom.png)

Zum Erzeugen von ``Circle``-Objekten sollen zwei Konstruktoren bereitgestellt werden:

1. Der erste Konstruktor ist parameterlos und erzeugt einen Einheitskreis, dessen _Mittelpunkt_ (nicht der Ursprungspunkt) im Koordinatenursprung liegt.
2. Der zweite Konstruktor übernimmt den übergebenen Ursprungspunkt und Radius.

Mit den Gettern können der Radius (``get_radius``), der Durchmesser (``get_diameter``), und der Mittelpunkt des Kreises (``get_center``) ermittelt werden.

Zudem steht ein Setter für den Radius (``set_radius``) zur Verfügung.

## Aufgabe 2: Distanzen berechnen

Fügen Sie dem ``Point`` die im UML-Diagramm abgebildete Methode ``distance_to`` hinzu. Diese berechnet die euklidische Distanz (Abstand) zum übergebenen Punkt und gibt diese dann zurück.

Fügen Sie zum ``Circle`` nun auch noch ``is_inside`` hinzu. Diese Methode gibt ``true`` zurück, wenn der übergebene ``Point`` innerhalb des Kreises (der Kreisrand gehört nicht zum Kreis) liegt (sonst ``false``). Sie können in der Methode auf ``distance_to`` vom ``Point`` zurückgreifen.

## Aufgabe 3: ``Circle`` - Fehlerbehandlung

Ein Radius ``<= 0`` ist wenig sinnvoll.

Verhindern Sie dies und werfen Sie (``throw``) an allen relevanten Stellen einen ``std::runtime_error`` (verfügbar in ``<stdexcept>``).

## Aufgabe 4: ``Point`` - Fehlerbehandlung

Dies ist eine mehr akademische Übung:

Wir gehen davon aus, dass Punkte nur in einem Bereich von ``(-1000, 1000)`` gültig sind.

Werfen Sie einen ``std::runtime_error``, wenn eine der Koordinaten außerhalb liegt.

## Aufgabe 5: Monte Carlo Integration (*)

### Vorwort

Mit der Monte-Carlo-Integration kann der Flächeninhalt von Objekten angenähert werden. Dazu wird um das Zielobjekt eine Bounding Box gelegt. Eine Bounding Box ist das kleinste Rechteck, welches das Objekt vollkommen umschließt. Anschließend werden sehr viele zufällige Punkte innerhalb der Bounding Box erzeugt und es wird gezählt, wie viele Punkte innerhalb und außerhalb des Objektes gelandet sind. Das Verhältnis ist dann der Flächeninhalt.

![Das schwarze Quadrat ist die Bounding Box des Kreises. Blaue Punkte liegen im Kreis, rote Punkte liegen außerhalb des Kreises (aber innerhalb der Bounding Box)](mc.png)

### Die Aufgabe: π-raten

Mit diesem Verfahren lässt sich auch π annähern. Dies wird nun Ihre Aufgabe sein.

Gehen Sie dazu folgendermaßen vor:

1. Legen Sie einen Einheitskreis im Koordinatenursprung an
2. Erzeugen Sie mindestens ``1000`` zufällige Punkte im Bereich ``(-1, 1)`` (dies ist die Bounding Box). Wie man Zufallszahlen erzeugt haben wir bereits behandelt.
3. Zählen Sie, wie viele der Punkte im Einheitskreis liegen
4. Berechnen Sie π mittels folgender Formel: ``A = π = Punkte_im_Kreis / Anzahl_Punkte * 4`` (4 ist Breite mal Höhe der Bounding Box, also ``2 * 2``)

Viel Erfolg!
