#include "circle.h"

#include <stdexcept>

Circle::Circle() {
    radius = 1.0;
    top_left = Point(-1, -1);
}

Circle::Circle(Point top_left, double radius) {
    this->top_left = top_left;
    set_radius(radius);
}

double Circle::get_radius() const {
    return radius;
}

void Circle::set_radius(double radius) {
    if (radius <= 0) {
        throw std::runtime_error("radius <= 0 ist unzulässig");
    }

    this->radius = radius;
}

double Circle::get_diameter() const {
    return 2 * radius;
}

Point Circle::get_center() const {
    // Option 1
    Point mittelpunkt(
        top_left.get_x() + radius,
        top_left.get_y() + radius
    );

    // Option 2
    Point mittelpunkt2 = top_left;
    mittelpunkt2.move_by(radius, radius);

    return mittelpunkt;
}

bool Circle::is_inside(const Point& p) const {
    Point mittelpunkt = get_center();

    return (mittelpunkt.distance_to(p) < radius);
}
