#include <SDL.h>
#include <cstdlib> // atexit
#include <iostream>
#include <memory> // std::unique_ptr

#include "sdl_helper.h"

// WICHTIG:
// SDL2 unter Windows benoetigt unbedingt main(int, char**), sonst gibt es einen Fehler
// Die Variablennamen für die Parameter wurden weggelassen, sonst gibt es Compilerwarnungen
// (ungenutzter Parameter)
int main(int, char**) {
    // Hilfsklasse aufrufen, die für uns SDL initialisiert
    SDL_Helper sdl_helper;

    SDL_Renderer* renderer = sdl_helper.get_renderer();

    /* Event Loop */
    for (;;) {
        // Nutzereingaben verarbeiten
        SDL_Event evt;

        // Events einlesen
        // siehe https://wiki.libsdl.org/SDL_Event
        while (SDL_PollEvent(&evt)) {
            // Jeweils ein Event verarbeiten
            if (evt.type == SDL_QUIT) {
                // Benutzer hat Programmende angefordert
                return 0;
            }
        }

        /* Updatelogik */
        // Rechteck definiert mit X, Y, Breite (w) und Höhe (h)
        SDL_Rect rect = { 0, 0, 100, 50 };

        /* Zeichnen / Rendern */
        // Fenster schwarz ausmalen
        SDL_SetRenderDrawColor(renderer, 0x0, 0x0, 0x0, 0xFF);
        SDL_RenderClear(renderer);

        // Zeichenfarbe auf rot setzen
        SDL_SetRenderDrawColor(renderer, 0xFF, 0x0, 0x0, 0xFF);

        // Rechteck zeichnen
        SDL_RenderFillRect(renderer, &rect);

        // Aenderung sichtbar machen
        SDL_RenderPresent(renderer);
    }

    return 0;
}
