#pragma once

#include <SDL.h>
#include <vector>
#include "rectangle.h"

class Engine {
public:
    Engine(SDL_Renderer* renderer, int window_width, int window_height);

    /**
     * Reagiert auf Benutzerevents.
     * Bei Rückgabe von false wird das Programm beendet.
     */
    bool process_events();

    /**
     * Reagiert auf das Ergebnis der Eventverarbeitung und zeichnet die Szene.
     * Für ein richtiges Spiel zu einfach, dort laufen update & render unabhängig.
     */
    void update_and_render();

private:
    SDL_Renderer* renderer;
    int window_width;
    int window_height;
};
