#pragma once

#include "sprite.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    int item_at(int row, int col) const;

    void set_item_at(int row, int col, int value);

    int count_neighbours(int row, int col) const;

    void draw(SDL_Renderer* renderer) override;

    void update_field();

    void clear();

    const int field_dim = 30;
    const int rect_dim = 24;
private:
    std::vector<std::vector<int>> field;
};
