#pragma once

#include <SDL.h>
#include "point.h"

class Sprite {
public:
    // virtual: Kann von Kindklassen überschrieben werden
    virtual void update();

    // = 0: pure virtual: MUSS von Kindklassen überschrieben werden
    virtual void draw(SDL_Renderer* renderer) = 0;

    void set_color(unsigned char red, unsigned char green, unsigned char blue);

    Point position; // Position im Raum
    Point velocity; // Geschwindigkeit (vektoriell)

    unsigned char red = 0;
    unsigned char green = 0;
    unsigned char blue = 0;
};
