#pragma once

#include "sprite.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    void draw(SDL_Renderer* renderer) override;

    void update_field();

    void set_direction(int new_direction);

    void place_food();

    const int field_dim = 30;
    const int rect_dim = 24;

    const int up = 0;
    const int down = 1;
    const int left = 2;
    const int right = 3;

private:
    std::vector<Point> snake;
    Point food;

    int tick = 0;
    double ticks_per_move = 10;
    int direction = right;
    bool game_over = false;
    bool did_eat = false;
};
