#include "engine.h"

Engine::Engine(SDL_Renderer* renderer, int window_width, int window_height) {
    this->renderer = renderer;
    this->window_width = window_width;
    this->window_height = window_height;
}

bool Engine::process_events() {
    SDL_Event evt;

    while (SDL_PollEvent(&evt)) {
        // Jeweils ein Event verarbeiten
        if (evt.type == SDL_QUIT) {
            // Benutzer hat Programmende angefordert (Fenster geschlossen)
            return false;
        } else if (evt.type == SDL_KEYDOWN) {
            if (evt.key.keysym.scancode == SDL_SCANCODE_SPACE) {
                pause = !pause;
            } else if (evt.key.keysym.scancode == SDL_SCANCODE_UP) {
                board.set_direction(board.up);
            } else if (evt.key.keysym.scancode == SDL_SCANCODE_DOWN) {
                board.set_direction(board.down);
            } else if (evt.key.keysym.scancode == SDL_SCANCODE_LEFT) {
                board.set_direction(board.left);
            } else if (evt.key.keysym.scancode == SDL_SCANCODE_RIGHT) {
                board.set_direction(board.right);
            }
        }
    }

    return true;
}

void Engine::update_and_render() {
    // Fenster weiß ausmalen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF);
    SDL_RenderClear(renderer);

    /* Eigener Code hier */
    if (!pause) {
        board.update_field();
    }
    board.draw(renderer);

    // Aenderungen sichtbar machen
    SDL_RenderPresent(renderer);
}
