# 0

Es gibt mehrere Möglichkeiten Quelltext zu formatieren.

Daher schauen wir uns hier mal einige Programmierstile an.

[Wikipedia hat dazu auch einen ausführlichen Artikel](https://en.wikipedia.org/wiki/Indentation_style)

# 1

Das lässt sich hier nicht darstellen, aber die erste Grundsatzdiskussion ist immer mit welchen Zeichen die Einrückung erfolgen soll.

Quelltext kann mit Leerzeichen oder mit Tabulator eingerückt werden.

Ein Tabulator entspricht dabei einer Einrückungsebene. Das Problem am Tabulator ist, dass die optische Einrückung vom Editor abhängt. Die üblichen Einrückungen sind dabei 4 oder 8. Es sieht eventuell bei den Entwicklern verschieden aus. Normalerweise verwendet jeder Editor aber mittlerweile 4.

Verdrängt wurde der Tabulator durch die Einrückung mit Leerzeichen. Diese sehen bei jedem gleich aus und können projektabhängig konfiguriert werden. Üblich sind 2, 4 oder 8. Bei C++ nimmt man in der Regel 4.

Leerzeichen zum Einrücken verwendet man aber nur bei Quelltext, _nicht in Word!_.

# 2

Variablen können auf verschiedene Arten benannt werden.

Das Verbinden mehrere Wörter mit dem Unterstrich (``_``) nennt man _Snake Case_.

Das ist die übliche Art Variablen in C++ zu benennen.

# 3

Den ersten Buchstaben klein schreiben und jedes neue Wort in Großbuchstaben heißt _Camel Case_.

# 4

Alle Anfangsbuchstaben groß schreiben heißt _Pascal Case_, weil dies in der Programmiersprache Pascal üblich war.

Das ist für Variablennamen unüblich.

# 5

Wo man Leerräume einfügt ist auch vom Programmierstil abhängig.

# 6

Hier sind keine Leerzeichen zwischen den Operatoren.

# 7

Dies ist die gleiche Anweisung wie darüber, aber mit Leerzeichen.

Diese verwende ich immer.

## Welche Variante findest du lesbarer? (Bei den Fragen in diesem Storyteller gibt es keine falschen Antworten. Ich kann aber nur eine richtige Antwort einstellen - Softwarelimitierung)

* Die 1. Variante
- Die 2. Variante

# 8

Das setzen der Leerräume kann man auch bei Ausdrücken wie dem ``if`` fortsetzen.

Hier werden wie im vorherigen Block Leerzeichen zwischen den Operatoren eingefügt.

# 9

Hier nochmal ohne Leerraum.

# 10

Und hier mit Leerraum vor und nach den Klammern.

## Welche Variante ist dein Favorit?

* Die 1. Variante
- Die 2. Variante
- Die 3. Variante

# 11

Bei Python kein Thema, da die Einrückung syntaktisch erzwungen wird, ist die Positionierung der geschweiften Klammern ``{}``.

Dafür gibt es unzählige Möglichkeiten.

# 12

Das ist die Einrückung nach _K&R_ (Kernighan & Ritchie). Dennis Ritchie ist der Erfinder von C. C++ baut auf C auf.

Die öffnene Klammer ist auf der gleichen Zeile wie die Anweisung und die schließende ist auf der gleichen Ebene wie das ``if``.

Diese ist ziemlich weit verbreitet und hat den Vorteil, weniger vertikalen Platz zu verbrauchen als andere Stile.

# 13

Das ist die Einrückung nach _Allman_. Eric Allman hat viele Unix-Programme entwickelt.

Anders als K&R ist hier die öffnende geschweifte Klammer auf einer neuen Zeile und mit der schließenden in der gleichen Spalte.

Der Vorteil ist hier, dass die Klammern leichter optisch zugeordnet werden können. Nachteilig ist der größere Platzverbrauch.

# 14

Das ist _Whitesmith_, benannt nach dem ersten kommerziellen C-Compiler, da die Einrückung dort verwendet wurde.

Dieser Stil entspricht Allman, aber die geschweiften Klammern sind zusammen mit dem Code in der Ebene eingerückt.

# 15

Dieser Stil heißt _GNU_. GNU ist eine Sammlung von freier Linux-Kommandozeilen-Software. Dieser Stil ist bei Richard Stallmann sehr beliebt. Dies ist einer der Gründer des GNU-Projektes.

Die Klammern sind hier um die halbe Einrückungsebene eingerückt.

Dieser Stil ist verpönt. Von ihm wird generell abgeraten. Abgesehen von Stallmanns eigenem Editor (Emacs) kann fast kein Programm diese Einrückung automatisch durchführen.

Linus Torvalds schreibt in den Code Guidelines für den Linux Kernel dazu: _First off, I'd suggest printing out a copy of the GNU coding standards, and NOT read it.  Burn them, it's a great symbolic gesture._

## Welcher Stil bist du?

* K&R
- Allman
- Whitesmith
- GNU

# 16

Welchen Stil man verwendet ist natürlich jedem freigestellt.

Wichtig ist nur: Der Stil sollte im gesamten Projekt konsistent sein.
