# 0

Zum Abschluss schauen wir uns noch einen neuen Datentyp an: Den ``vector``.

Ein ``vector`` verhält sich fast wie ein String, kann aber beliebige Datentypen aufnehmen.

Neben ``vector`` gibt es übrigens auch noch ``array``. ``array`` haben eine konstante Größe und sind daher weniger flexibel einsetzbar. Wir konzentrieren uns daher primär auf ``vector``.

# 1

Zuerst benötigen wir einen neuen Header: ``vector``. Ein sehr naheliegender Name.

# 2

Um einen Vektor zu definieren, muss zusätzlich noch der _Datentyp_ mit angegeben werden. Dazu werden wie beim ``static_cast`` die spitzen Klammern (``<>``) verwendet.

Diese Anweisung erzeugt einen leeren Vektor, der nur Werte vom Typ ``int`` aufnehmen kann.

Vektoren, die belibige Datentypen aufnehmen können, sind nicht möglich. Hier sind Sprachen mit dynamischen Datentypen (Python) klar im Vorteil.

# 3

Dieser Vektor kann nur Zeichen aufnehmen.

Dieses Konstrukt ist fast wie ein String, kann aber nicht mit ``cout`` ausgegeben werden.

Hier kommt es mehr auf die Semantik an:

- Wenn man mit Wörtern arbeitet, verwendet man eher ``std::string``
- Wenn man mit einzelnen Zeichen arbeitet, verwendet man eher ``std::vector<char>``

# 4

Diese Syntax initialisiert den Vektor mit den übergebenen Zahlen.

Er enthält nun also fünf Elemente: ``1``, ``-3``, ``12``, ``7`` und ``15``.

# 5

Die Methoden auf dem Vektor entsprechen denen des Strings.

## Was gibt ``size()`` hier zurück?

- ``0``
- ``3``
* ``5``
- ``7``

# 6

## Was gibt ``front()`` hier zurück?

- ``0``
* ``1``
- ``-3``
- ``12``
- ``15``

# 7

## Was gibt diese Anweisung zurück?

- ``0``
- ``1``
* ``-3``
- ``12``
- ``15``

# 8

Das hier ist die erste neue Methode und auch eine der wichtigsten: ``push_back``

Damit werden einzelne Elemente hinten an den Vektor angefügt.

Der Vektor ist nun also um eins länger und das letzte Element ist der Wert von ``neue_zahl``.

# 9

Und hier geben wir das letzte Element im Vektor, also den Wert von ``neue_zahl``, aus.

# 10

``pop_back`` ist das Gegenteil von ``push_back``: Das letzte Element wird aus dem Vektor entfernt.

Natürlich kann auch in der Mitte eingefügt und gelöscht werden. Damit beschäftigen wir uns aber später.
