# 0

Hier behandeln wir _Scopes_.

Scopes legen fest, wo eine Variable sichtbar ist.

Die Scopes sind in C++ auch wichtig für die Speicherverwaltung.

Wenn eine Variable aus dem Scope fällt, wird der von ihr belegte Speicher freigegeben.

Diese Scoping-Regeln funktionieren bei Schleifen auf die gleiche Art.

Dieses Verhalten ist anders als beispielsweise in Python, wo ein Garbage Collector verwendet wird.
Garbage Collectors analysieren im Hintergrund, welche Variablen nicht mehr erreichbar sind und geben diese irgendwann frei.

# 1

Die Variable ``a`` ist offensichtlich in der gesamten ``main``-Funktion verfügbar.

# 2

Interessanter ist Variable ``b``.

Jeder Block von geschweiften Klammern definiert ein Scope, d.h. die Variable ``b`` ist nicht außerhalb der geschweiften Klammern verfügbar.

Die Variable ``b`` ist also außerhalb der ``if``-Bedingung nicht verfügbar.

Python verwendet übrigens andere Scoping-Regeln. ``b`` ist in Python in der Gesamten ``main`` verfügbar.

# 3

## Kompiliert dieser Code?

- Natürlich, und er gibt ``52`` aus.
* Nein, weil ``b`` nicht im aktuellen Scope verfügbar ist.

# 4

Mit dieser kleinen Änderung lässt sich das Problem beheben.

Die Variable ``b`` ist nun im gesamten Scope von ``main`` verfügbar.

Überraschenderweise gibt der Code nun ``42`` aus.

Wo ist das Problem? Die Variable ``b`` wird zweimal definiert.

Das innere ``b`` verdeckt nun das äußere ``b``. Der Fachgriff ist ``shawdowing``. Compiler erkennen das und warnen davor.

# 4

Durch das Entfernen des ``int`` im inneren Block lässt sich das Problem lösen.

Das ``b`` bezieht sich nun auf die äußere Variable.
