# 0

Letzte Woche haben wir die foreach-Schleife kennengelernt.

Hier schauen wir uns die normale for-Schleife an.

Aufgepasst werden muss bei den Schlüsselwörtern.
Sowohl foreach-, als auch for-Schleife beginnen mit dem Schlüsselwort ``for``.
Das liegt einfach daran, dass die foreach-Schleife erst mit C++11 (also 2011) dazukam und man keine alten Programme
kaputt machen möchte, wenn neue Schlüsselwörter reserviert werden.

# 1

Das hier ist eine for-Schleife.

Der syntaktische Unterschied sollte sofort ersichtlich sein.

Eine for-Schleife enthält zwei Semikola und eine foreach-Schleife enthält einen Doppelpunkt.

Durch die Semikola wird der Schleifenkopf also in drei Bereiche unterteilt:

# 2

Das ist die _Initialisierung_. Diese Anweisung wird vor dem ersten Schleifendurchlauf ausgeführt. Normalerweise wird hier eine Zählvariable initialisiert.

# 3

Das ist die _Abbruchbedingung_. Wenn diese Bedingung falsch ist, wird die Schleife abgebrochen. Wenn die Bedingung schon am Anfang falsch ist, wird die Schleife gar nicht ausgeführt. Bei jedem weiteren Durchlauf wird die Bedingung wird nach der Erhöhung im _Schritt_ überprüft.

# 4

Das ist der _Schritt_. Diese Anweisung wird bei jeder Schleifenwiederholung ausgeführt. Normalerweise wird hier die Zählvariable um 1 erhöht oder verringert.

# 5

Diese Schleife gibt einfach nur die Elemente in einem Vektor aus.

Wenn man einen kompletten Vektor durchläuft, ist bis auf wenige Ausnahmen eine foreach-Schleife immer die bessere Möglichkeit.

# 6

Hier ist eine der seltenen Ausnahmen:

Bei foreach-Schleifen steht der Index nicht zur Verfügung.

# 7

Eigentlich muss hier ``size_t`` verwendet werden.

Das ist ein vorzeichenloser Ganzzahltyp, der groß genug ist, um alle gültigen Indizes enthalten zu können.

Normalerweise ist er 64 Bit groß.

In den meisten Fällen ist es aber vollkommen harmlos auch hier mit ``ìnt`` zu arbeiten, da das Problem erst bei sehr großen Vektoren (2^31 Elementen) auftritt.

# 8

Bei dieser for-Schleife ist foreach gar nicht möglich, da kein Vektor durchlaufen wird.

## Was gibt diese Schleife aus?

* Die Zahlen von 0 bis 9
- Die Zahlen von 1 bis 10

# 9

Und natürlich kann in einer for-Schleife jegliche Anweisung stehen

## Was gibt diese Schleife aus?

- Die Zahlen 1, 3, 5, 7, 9
* Die Zahlen 0, 2, 4, 6, 8
- Die Zahlen 1, 3, 5, 7, 9, 11
- Die Zahlen 0, 2, 4, 6, 8, 10
