# 0

Neben der for-Schleife gibt es noch die while-Schleife.

Die beiden Schleifen sind funktional äquivalent. Lassen sich also ineinander überführen.

# 1

Die _Initialisierung_ muss vor der ``while``-Anweisung stehen.

Der Unterschied ist hier der _Scope_:
Die Variable ist hier außerhalb der Schleife verfügbar. Bei der for-Schleife ist die Variable nur innerhalb verfügbar.

# 2

Die _Abbruchbedingung_ steht in der Anweisung.

Wenn die Anweisung bereits am Anfang falsch ist, wird die Schleife gar nicht ausgeführt.

# 3

Der _Schritt_ ist die letzte Anweisung der while-Schleife.

# 4

Mit ``continue`` wird der nächste Schleifendurchlauf direkt ausgeführt.

Das funktioniert auch in allen anderen Schleifen.

Durch das ``continue`` entsteht hier aber ein Bug: Die Erhöhung von ``i`` findet nicht statt.

Wenn es einen solchen Zähler gibt, muss also gut aufgepasst werden oder man verwendet einfach eine for-Schleife,
da dort das Erhöhen auch bei ``continue`` korrekt funktioniert.

# 5

Mit dieser Änderung ist der Fehler behoben.

## Was für Zahlen gibt die Schleife aus?

- 0, 1, 2, 3, 4, 5, 6, 7, 8, 9
* 0, 1, 2, 4, 5, 7, 8
- 1, 2, 3, 4, 5, 6, 7, 8, 9
- 1, 2, 4, 5, 7, 8

# 6

Mit ``break`` wird die aktuelle Schleife abgebrochen.

Die Ausführung wird am Ende der Schleife fortgesetzt.

Das funktioniert auch in allen anderen Schleifen.

## Was für Zahlen gibt die Schleife aus?

- 0, 1, 2, 3, 4, 5
- 0, 1, 2, 4, 5
- 0, 1, 2, 3, 4
* 0, 1, 2, 4
