# 0

In den letzten drei Storys lernen wir noch Funktionen kennen.

Funktionen verwendet man, um Code wiederverwendbar zu machen.


# 1

Zur Information: Wenn man mehrere Variablen des gleichen Typs definiert, können diese auch kommagetrennt auf einer Zeile geschrieben werden.

# 2

Dieser Block ermittelt von den Beiden eingegebenen Zahlen die Kleinere.

Das kann man so machen, aber es wird problematisch, wenn die kleinere Zahl mehrmals ermittelt werden soll.

# 3

Beispielsweise hier. Die Bestimmung der kleineren Zahl sieht jetzt zweimal fast gleich aus.

Jetzt stellen wir uns vor, der doppelte Code sind keine 5 Zeilen, sondern 50 Zeilen.
Der Code wird schwer zu lesen und wenn man in den 50 Zeilen einen Fehler findet, muss man daran denken, ihn auch in allen Kopien zu korrigieren.

Das skaliert also einfach nicht.

# 4

Die Lösung dafür sind Funktionen.

Syntaktisch sind Funktionen bereits bekannt: ``main`` ist auch eine Funktion.

# 5

Syntaktisch bestehen Funktionen aus vier Komponenten:

Ganz links ist der _Rückgabewert_.

Das ist also der Datentyp, der von der Funktion mit ``return`` an den Anrufenden zurückgegeben wird.

Wenn eine Funktion keine Rückgabe hat, muss hier ``void`` stehen.

# 6

Direkt vor der öffnenden Klammer ist der _Funktionsname_.

Unter diesem Namen ist die Funktion bekannt.

Funktionsnamen können mehrfach vergeben werden, sofern die _Signatur_ anders ist, d.h. solange die Parameterliste unterschiedlich ist.

Der Rückgabewert gehört nicht zur Signatur. Beispielsweise ist Folgendes unzulässig:

- ``int min(int a, int b)``
- ``double min(int a, int b)``

Diese beiden Funktionen unterscheiden sich nur hinsichtlich des Rückgabewertes.

# 7

In den Klammern ist kommagetrennt die _Parameterliste_.

Diese Werte müssen also vom Aufrufenden übergeben werden.

In unserem Fall akzeptiert die Funktionen zwei Parameter vom Typ ``int``.

# 8

Innerhalb der geschweiften Klammern stehen dann die Anweisungen für die Funktion.

Das funktioniert exakt so, wie bei ``main``.

Wichtig ist noch, dass Funktionen einen _Scope_ bilden.

Die Variablen aus ``main`` sind nicht in der Funktion sichtbar und die Variablen aus ``min`` sind nicht in ``main`` sichtbar.
Die Kommunikation erfolgt nur über die Parameter und den Rückgabewert.

# 9

Die Implementierung ist exakt so wie auch schon das Original in ``main``.

# 10

Jetzt ändern wir die ``main``-Funktion noch so ab, dass die Funktion aufgerufen wird und dann sind wir auch schon fertig.

Wir sind uns hoffentlich einig, dass dies wesentlich übersichtlicher ist.

# 11

Besonders guter Stil sind dann noch Dokumentationskommentare.

Das ist ein Kommentar im Stil _Javadoc_.

Javadoc fangen mit ``/**`` und hören mit ``*/`` auf.
Zudem ist am Anfang jeder Zeile ein ``*``.

Inhaltlich ist die Struktur:

1. Eine Erläuterung der Funktion.
2. Für jeden Parameter eine Zeile mit ``@param``, die den konkreten Parameter erläutert.
3. Am Ende steht eine Zeile mit ``@return``, welche die Rückgabe der Funktion erläutert. Natürlich nur bei Funktionen, die einen Rückgabewert haben.

Die Dokumentation wird von der Entwicklungsumgebung automatisch extrahiert und dem Nutzer angezeigt, sobald er die Funktion aufruft.
