# 0

Hier schauen wir uns eine weitere Funktion an und lernen, wie man Vektoren effizient als Parameter übergibt.

C++ gibt uns sehr viele Freiheiten bei der Parameterübergabe.

# 1

Zuerst wird eine Funktion namens ``sum`` definiert, die einen ``vector<int>`` akzeptiert und am Ende eine Ganzzahl zurückgibt.

Die Rückgabe soll der Summe aller Elemente im Vektor entsprechen.

# 2

Hier sind beispielhaft die Aufrufe der Funktion zu sehen.

Wie die Rückgabewerte dann konkret verwendet werden, ist hier im Beispiel ausgelassen.

# 3

Zuerst wird eine lokale Variable namens ``s`` definiert.

Diese wird das Zwischenergebnis der Addition enthalten.

# 4

Nun durchlaufen wir den Vektor mit einer foreach-Schleife.

# 5

In der Schleife wird jedes Element der Schleife (also ``x``) auf ``s`` addiert.

Angenommen der Vektor enthält ``1, 3, -5``, dann sind die Einzelschritte:

1. ``s += 1;  // s war 0 und ist nun 1``
2. ``s += 3;  // s war 1 und ist nun 4``
3. ``s += -4; // s war 4 und ist nun -1``

# 6

Abschließend wird die ermittelte Summe zurückgegeben.

# 7

Zum Abschluss noch ein hübscher Dokumentationskommentar.

Immer an die Kommentare denken, sonst weiß man in 6 Monaten nicht mehr, was der Code macht ;).

# 8

Okay, ganz fertig sind wir noch nicht.

Tief durchatmen, denn jetzt kommen noch zwei fortgeschrittene Themen, die wir auch in der Vorlesung vertiefen werden.

Ein Problem hat die Übergabe des Vektors an die Funktion: Der komplette Vektor wird _kopiert_, d.h. alle Elemente werden im Speicher kopiert. Die Übergabe des Vektors hat also eine Komplexität von O(n), wobei n die Anzahl an Elementen ist.

Bei vier Elementen ist das natürlich komplett egal, aber stellen wir uns mal einen Vektor mit 10 Millionen Elementen vor. Das ist eine riesige Zeit- und Speicherverschwendung.

Die Lösung ist dieses kleine kaufmännische Und (``&``).

Das ``&`` bedeutet hier: _Referenz_.

Bei Referenzen wird nur die Adresse des Vektors übergeben und ist somit komplett unabhängig von dessen Länge.

Sofern man also nicht explizit eine Kopie möchte, ist dies die typische Art Vektoren und auch Strings zu übergeben.

Bei Zahlen sind Referenzen nicht notwendig, da diese höchstens acht Byte groß sind und daher in ein Prozessorregister passen.

# 9

Mit dem Schlüsselwort ``const`` teilt man dem Entwickler mit, dass diese Funktion den Vektor nicht modifizieren wird.

Das Verhalten wird auch vom Compiler erzwungen. Funktionen wie ``push_back`` und ``pop_back``, die den Vektor modifizieren, sind nun in ``sum`` nicht mehr aufrufbar.

Der Fachbegriff hier ist _const correctness_.

# 10

``const`` lässt sich auch nutzen, um Konstanten zu definieren.

Die Werte von ``summe`` und ``summe2`` können nun nicht mehr überschrieben werden.
