# 0

Abschließend noch eine Möglichkeit, wie fehlerhafte Eingaben bei ``cin`` behandelt werden können.

Momentan ist noch das Problem, dass beispielsweise bei der Eingabe eines Buchstabens, wenn eine Zahl gelesen wird, dass Programm anfängt zu spinnen.

So ein problematisches Programm ist hier dargestellt.

Wenn der Nutzer anstatt der ersten Zahl einen Buchstaben eingibt, wird der Nutzer gar nicht mehr nach der zweiten gefragt und es wird Blödsinn berechnet.

# 1

Als ersten Lösungsansatz erstellen wir eine neue Funktion ``lese_zahl``.

Diese bekommt als Parameter den Text übergeben, der dem Benutzer angezeigt wird.

Anschließend wird eine Zahl gelesen und diese zurückgegeben.

Dies löst das Problem natürlich noch nicht.

# 2

Zudem wird der Code so geändert, dass die Funktion nun aufgerufen wird.

# 3

Das hier ist die Lösung des Problems.

Aber gehen wir es besser mal Schritt für Schritt durch.

# 4

``std::cin`` gibt den Status des Eingabestreams zurück.

Wenn das Lesen fehlschlug, ist der Rückgabewert also ``false``.

Solange der Stream also _nicht in Ordnung_ ist (_nicht_ wird signalisiert mit dem ``!``), wird die while-Schleife ausgeführt.

# 5

``cin.clear()`` entfernt den Fehlerstatus vom Stream. Diese Operation ist notwendig, da sonst der Stream nicht mehr funktioniert.

# 6

``cin.ignore()`` liest ein Zeichen von der Eingabe und verwirft es.

# 7

Angenommen die Eingabe war ``abcde``, dann wird die Schleife fünfmal ausgeführt und verwirft der Reihe nach alle fünf Buchstaben.

Angenommen die Eingabe war ``abcde15``, dann wird die Schleife fünfmal ausgeführt und verwirft der Reihe nach alle fünf Buchstaben. Die Zahl ist aber ein gültiges Zeichen, daher wird hier die ``15`` als Zahl gelesen.

# 8

Der Text wird bei der Übergabe übrigens kopiert.

Um das zu verhindern, hilft der gleiche Trick wie beim Vektor: die Referenz ``&``.

Zudem wird der Text von der Funktion nicht modifiziert, daher wird auch noch ``const`` mit angegeben.
