# 0

Im nachfolgenden Beispiel wollen wir zählen, wie oft ein konkreter Wert in einem Vektor vorkommt.

# 1

Der naheliegende Ansatz wäre eine Funktion wie hier.

In der Schleife wird gezählt, wird oft die ``1`` im Vektor vorkommt.

Dies ist natürlich sehr inflexibel, aber es funktioniert.

# 2

Etwas besser ist nachfolgender Ansatz, da der Wert als zusätzlicher Parameter übergeben wird.

Dadurch ist die Funktion wesentlich flexibler, weil beliebige Werte gezählt werden können.

# 3

Aber eigentlich hätten wir uns dies alles sparen können, denn jetzt werfen wir einen Blick auf ``<algorithm>``.

Dort finden sich sehr viele nützliche Algorithmen, die man dann nicht selbst programmieren muss.

[Zur Referenz](https://en.cppreference.com/w/cpp/algorithm)

Bei der Referenz ist zu beachten, dass mit Sprachstandard C++20 ``ranges`` hinzukamen, welche die Referenz ziemlich unübersichtlich machen, da es so viele sind. Diese werden wir nicht behandeln.

# 4

Die Zählfunktion heißt ``std::count``.

Diese akzeptiert drei Parameter:

1. Den Anfang der Sequenz
2. Das Ende der Sequenz
3. Was gezählt werden soll

Anfang und Ende sind sogenannte Iteratoren. Was Iteratoren sind behandeln wir in der Vorlesung.

Das funktioniert übrigens auch alles bei Strings.

# 5

## Was zählt dieser Aufruf von ``std::count``?

- Wie oft die ``1`` im Vektor vorkommt
- Wie oft Zahlen im Vektor vorkommen
* Wie oft die ``4`` im Vektor vorkommt

# 6

Hier ist das Endergebnis: Der Code macht genau das Gleiche wie unser eigener Code.
Es müssen aber viel weniger Codezeilen geschrieben werden, da eingebaute Funktionalität genutzt wird.
