# 0

Fangen wir hier mal direkt mit einem komplexeren Beispiel an.

Gegeben sind zwei Funktionen mit denen gezählt werden kann, wie viele Zahlen gerade bzw. ungerade sind.

Hier funktioniert ``std::count`` nicht, da wir nicht auf einen konstanten Wert prüfen.

# 1

Dennoch: ``<algorithm>`` zu unserer Rettung!

# 2

``std::count_if`` ist wie ``std::count``, aber es wird bedingt gezählt.

# 3

Bis hierhin nichts Neues, aber gleich wird es spannend!

# 4

Das ist eine _Lambda-Funktion_.

Lambda-Funktionen sind syntaktisch fast wie normale Funktionen, werden aber _inline_, also direkt hingeschrieben und nicht woanders definiert.

``count_if`` übergibt an die Funktion jedes Element des Vektors und wenn die Lambda-Funktion ``true`` zurückgibt, wird das Element gezählt, ansonsten nicht.

# 5

Die eckigen Klammern ``[]`` stehen für die Bindung. In der eckigen Klammer wird angegeben, welche Variablen aus der übergeordneten Funktion innerhalb der Lambda-Funktion verfügbar sind.

Der übliche Fall ist _keine_. So wie auch hier, da die Klammer leer ist.

# 6

Das ist die Parameterliste. Diese ist exakt so wie bei normalen Funktionen. Anstatt ``auto`` hätten wir hier auch ``int`` schreiben können (da dies der Typ des Vektorelements ist). Mit ``auto`` bestimmt der Compiler automatisch den korrekten Typ.

# 7

Genau wie bei normalen Funktionen ist in geschweiften Klammern der Funktionsinhalt.

# 8

Der Typ des Rückgabewerts muss nicht angegeben werden gibt es nicht.
Der Compiler ermittelt diesen automatisch anhand des Ausdrucks hinter ``return``.

# 9

Jetzt nochmal auf die gleiche Art um ungerade Zahlen zu zählen.

# 10

Hier ist das Endergebnis: Der Code macht genau das Gleiche wie unser eigener Code.
Es müssen aber viel weniger Codezeilen geschrieben werden, da eingebaute Funktionalität genutzt wird.
