# 0

Hier lernen wir, wie man Elemente in Vektoren (funktioniert natürlich auch für Strings) ersetzt.

Dafür aber kein ``<algorithm>``, da dies mit foreach-Schleifen eleganter geht.

# 1

Wir möchten alle Zahlen in einem Vektor mit zwei multiplizieren.

Diese Lösung hier funktioniert nicht.

Warum? Ganz einfach: ``z`` ist eine Kopie der Zahl, d. h. die Kopie wird verdoppelt und die Änderung wird nie angewendet.

# 2

Das hier funktioniert nicht: Es wird eine neue Variable ``z`` erzeugt. Wir arbeiten also auf einer Kopie.

Können Sie sich die Lösung denken?

# 3

Die Lösung ist wieder die Referenz (``&``). Jetzt ist ``z`` keine Kopie, sondern eine Referenz auf die Zahl im Vektor.

Die Zahlen im Vektor werden nun also korrekt ersetzt.

Hier punktet C++ übrigens gegenüber Python: Bei Python sind Zahlen immer Kopien, daher muss dort über den Index ersetzt werden.

# 4

Mit einer Bedingung lässt sich nun _bedingt ersetzen_. Jetzt werden nur noch Zahlen verdoppelt, die vorher ``3`` waren.

# 5

Wir definieren hier beispielhaft einen neuen String.

Dieser enthält die Namen von Spalten und die Spaltennamen werden jeweils mit Semikolon voneinander getrennt.

So etwas sieht man oft in der ersten Zeile von CSV-Dateien.

Das Ziel ist nun die Semikola mit Kommas zu ersetzen.

# 6

Dafür verwenden wir hier die Funktion ``std::replace``. Diese kann aber nur verwendet werden, wenn Such- und Ersetzungsausdruck gleichlang sind.

Die Parameter sind:

1. Start
2. Ende
3. Suchausdruck
4. Ersetzung

Dieser Ausdruck ersetzt nun alle Semikola mit Kommas.

Zu beachten ist außerdem, dass hier keine Lambda-Funktion übergeben werden kann. Es kann also immer nur ein festgelegtes/konstantes Zeichen mit einem anderen ersetzt werden.

# 7

Einzelne Zahlen bzw. Zeichen können übrigens über den Index geändert werden.

Hier wird jetzt die erste Zahl mit einer ``42`` ersetzt.

# 8

Hier wird jetzt die dritte Zahl mit dem Wert der vierten Zahl ersetzt.

Achtung: Zählung beginnt bei 0!
