# 0

In diesem Beispiel entfernen wir Zeichen aus Text.

Auf die gleiche Art können auch Elemente aus Vektoren gelöscht werden.

# 1

In diesem Text möchten wir alle Leerzeichen entfernen.

Dafür gibt es ``std::remove``. Übergeben wird wieder der Bereich und im dann noch das zu entfernende Zeichen. In diesem Fall das Leerzeichen.

# 2

Anders als der Name vermuten lässt, werden die Zeichen aber von ``std::remove`` nicht gelöscht.

Stattdessen werden die Elemente in der Zeichenkette so umsortiert, dass die Leerzeichen nun am Ende des Strings stehen.

Der Start dieses Bereichs wird von ``std::remove`` zurückgegeben. Der konkrete Datentyp ist ``std::string::iterator``. Da uns der Typ aber nicht interessiert und auch hässlich lang ist, verwenden wir einfach ``auto``.

# 3

Wirklich gelöscht wird nun mit der Funktion ``erase`` vom String. Dort werden übergeben: die Rückgabe von ``std::remove`` und das String-Ende.

Warum ist das so umständlich mit diesen beiden Funktionen? Alles in ``<algorithm>`` operiert auf Bereichen, und wie ein Element gelöscht werden muss, ist von der darunterliegenden Datenstruktur abhängig.

# 4

Natürlich lässt sich dies auch beides auf eine einzelne Zeile reduzieren.

# 5

Wenn das Zeichen nicht konstant ist, kann ``std::remove_if`` verwendet werden.

Genau wie ``std::count_if`` wird hier wieder eine Lambda-Funktion erwartet.

Diese bekommt als Parameter das aktuelle Zeichen übergeben und muss dann einen Wahrheitswert zurückgeben (``true`` = löschen).

Hier im konkreten Fall werden alle Zeichen entfernt, die keine Buchstaben sind.

Bei der Bedingung bedienen wir uns beim Aufbau des ASCII-Codes: Wir wissen, dass die Buchstaben von A bis Z bzw. a bis z
direkt hintereinander stehen, daher müssen wir nur prüfen, ob das Zeichen in diesem Interval liegt.
