# 0

In diesen Storytellern lernen wir, wie man Dateien einliest, Dateien schreibt und von der Kommandozeile liest.

Dieser Storyteller beschäftigt sich mit dem Lesen von Dateien.

Dateiein- und Ausgabe erfüllt über Ströme (Streams). Diese kennen Sie bereits von der Konsole.

# 1

Zuerst benötigen wir einen neuen Header: ``<fstream>`` enthält Funktionen für die Dateiein- und Ausgabe

# 2

Mit dieser Anweisung wird die Datei ``assets/Hello``, also ``Hello`` im Unterordner ``assets``, geöffnet.

``std::ifstream`` ist ein Eingabestrom, auf Englisch _input stream_.

# 3

Um zeilenweise aus der Datei zu lesen, verwenden wir ``std::getline``.

Eine Zeile endet dabei bei einem Zeilenumbruch.

Die Parameter sind:

1. Stream aus dem gelesen wird. Hier kann übrigens auch die Konsole übergeben werden, um eine Zeile von der Konsole zu lesen, da diese auch ein Eingabestrom ist (also ``std::cout``)
2. Referenz auf einen String, in den hineingeschrieben wird.

# 4

Die gelesene Zeile kann nun ausgegeben werden.

# 5

Dies wiederholen wir nun für die zweite Zeile.

# 6

Jetzt fügen wir noch eine Fehlerbehandlung hinzu, sofern die Datei fehlt.

Dafür benötigen wir den Header ``<cstring>``, dieser stellt die Funktion ``strerror`` zur Verfügung.

# 7

Ein Stream lässt sich in einer Bedingung verwenden.

Wenn der Stream in der Bedingung ``false`` zurückgibt, ist das Öffnen der Datei fehlgeschlagen.

# 8

``std::cerr`` verhält sich fast wie ``std::cout``. ``std::cerr`` nimmt man normalerweise für Fehlermeldungen.

Der Unterschied ist, dass ``cout`` _gepuffert_ und ``cerr`` _ungepuffert_ ist.

Gepuffert bedeutet, dass der Text erst auf der Konsole erscheint, wenn der Zwischenspeicher (Puffer) voll ist. Puffern ist effizienter, da man für Textausgabe mit dem Betriebssystem kommunizieren muss (Kernel Call) und das relativ langsam ist, wenn man es ständig macht. Durch den Puffer werden diese Anfragen minimiert.

Bei ungepufferten Ausgaben erscheint der Text hingegen sofort auf der Konsole.

Spürbar ist der Unterschied aber eigentlich nur, wenn das Programm kurz darauf abstürzt. Dann sind manche Ausgaben in ``cout`` eventuell verloren, aber alle Ausgaben in ``cerr`` sind ausgegeben.

# 9

Mit ``strerror(errno)`` kann der Fehlercode vom Betriebssystem abgerufen werden und als menschenlesbarer Text angezeigt werden.

Angezeigt wird dann ein Fehler wie beispielsweise "Datei oder Verzeichnis nicht gefunden".
