# 0

In diesem Storyteller programmieren wir einen einfachen Kommandozeilen-Parser.

Sie kennen schon Programme wie ``ls``, wo ``-l`` die Langform aktiviert oder ``-a`` alle Dateien anzeigt, aber wie verarbeiten solche Programme die Kommandozeile?

Wohlgemerkt wird unser Parser sehr einfach sein. Dinge wie ``-la`` (kurz für ``-l`` und ``-a``) wird er nicht verarbeiten können.

Unser Programm soll das übergebene Wort entweder in Großbuchstaben oder in Kleinbuchstaben umwandeln.

# 1

Unser Programm soll die hier dargestellten Parameter verarbeiten können:

- ``-h`` bzw. ``--help`` soll diese Hilfe ausgeben.
- ``-u`` bzw. ``--upper`` soll das Wort in Großbuchstaben umwandeln.
- ``-l`` bzw. ``--lower`` soll das Wort in Kleinbuchstaben umwandeln.

Das ``print_help`` ``1`` zurückgibt dient nur dazu, dass verlassen des Programms eine Zeile kürzer zu machen. In der ``main`` können wir dann ``return print_help()`` anstatt ``print_help(); return 1;`` schreiben.

Ein Rückgabewert ungleich ``0`` ist nach Konvention ein nicht-normales Programmende. Wie wir die Werte aber belegen ist relativ egal.

# 2

Zuerst werden wir über alle Parameter, mit Ausnahme des Dateinamens, iterieren.

Da ``char**`` aber aus C stammt, können wir hier keine foreach-Schleife verwenden.

# 3

Den aktuellen Parameter konvertieren wir nun in einen ``std::string``.

# 4

Jetzt fügen wir alle Kombinationen an Parametern ein, die wir überprüfen wollen.

Den eigentlichen Code lassen wir vorerst leer.

# 5

Im Falle von ``-h`` gibt das Programm nun die Hilfe aus und bricht ab.

# 6

Im Falle von ``-u`` und ``-l`` setzen wir jeweils ein ``bool`` auf ``true``.

In diesen Variablen merken wir uns den Modus.

# 7

Wenn das Argument kein bekannter Parameter ist, nehmen wir an, dass es sich hierbei um das Wort handelt.

Wenn das Wort auftaucht, merken wir es uns und brechen mit ``break`` die Schleife ab.

# 8

Abhängig davon, ob ``upper`` oder ``lower`` gesetzt ist, wandeln wir das Wort nun in Groß- bzw. Kleinbuchstaben um.

Für das Umwandeln der Zeichen verwenden wir die Funktionen ``toupper`` bzw. ``tolower``. Diese befinden sich im Header ``<cctype>``.

# 9

Jetzt fügen wir noch etwas Fehlerbehandlung ein:

Wenn gar kein Parameter übergeben wurde, geben wir direkt die Hilfe aus und brechen ab.

# 10

Selbiges gilt, wenn kein Wort übergeben wurde oder sowohl _Großbuchstaben_, als auch _Kleinbuchstaben_ gefordert werden, da diese zwei Optionen zueinander widersprüchlich sind.
