# 0

Hier behandeln wir das Lesen von Binärdateien.

Binärdateien sind alle Dateien, die keinen menschenlesbaren Text enthalten.

Dazu gehören u. a. Bilder.

In diesem Beispiel werden wir eine Bilddatei (im BMP-Format) einlesen.

Der Aufbau des Bitmap-Headers ist noch aus dem letzten Semester bekannt und hier nochmal dargestellt.

**Dies ist ein fortschrittliches Thema, mit dem wir uns nicht weiter beschäftigen werden**. Wir werden uns ausschließlich mit Textdateien konkreter beschäftigen.

# 1

Um binäre Dateien zu lesen, müssen bitweise Oder-verknüpft (``|``) diese zwei Optionen übergeben werden. Ohne diese Optionen wird die Datei im Textmodus gelesen und einige Bytefolgen unterbrechen dann fälschlicherweise das Lesen der Datei.

# 2

Zuerst wollen wir den Header lesen.

Dafür wird hier ein Vektor erzeugt und mit ``resize(2)`` auf eine Größe von 2 Byte vergrößert (entspricht der Größe des Headers).

# 3

Nun wird mit ``read`` byteweise aus der Datei gelesen.

Die Parameter sind:

1. Zielpuffer
2. Anzahl zu lesende Bytes

Gelesen werden hier zwei Byte und der Zielpuffer ist ``header.data()``. ``data`` gibt den internen Puffer des Vektors zurück, der dadurch direkt beschrieben werden.

Bei allen Leseoperationen wird die Leseposition in der Datei geändert.
Der nächste Lesevorgang geht nun also hinter dem Header weiter.

# 4

Da der Header ``BM`` sein muss, überprüfen wir nun den Header auf Richtigkeit.

# 5

Da wir mit binären Daten arbeiten und daher die Größen exakt stimmen müssen, verwenden wir hier sicherheitshalber anstatt ``int`` den Datentyp ``int32_t``.

Dies ist eine vorzeichenbehaftete 32 Bit Ganzzahl, entspricht also auf quasi allen Plattformen ``int``.

Es würde daher auch mit ``int`` funktionieren, wir sind hier einfach exakt.

# 6

Mit ``&size`` bekommen wir die Adresse von ``size``. Dies ist also der Puffer, wo die nächsten Byte hineingeschrieben werden sollen.

``read`` möchte aber einen Puffer vom Typ ``char*``, der aktuelle Typ ist aber ``int32_t*``.

Um dem Compiler zu signalisieren "Ich weiß, was ich tue, vertraue mir", kann mit ``reinterpret_cast`` ein anderer Datentyp _erzwungen_ werden.
Wir sagen dem Compiler hier also: Nimm an, dass Ziel ist ein ``char*``-Puffer und schreibe hinein.

``reinterpret_cast`` ist also deutlich gefährlicher als ein ``static_cast``. Bei einem ``static_cast`` kann nur zwischen kompatiblen Datentypen konvertiert werden. ``reinterpret_cast`` akzeptiert quasi alles.

# 7

Das ``sizeof(int32_t)`` gibt ``4`` zurück, da der Datentyp 32 Bit groß ist.

Es werden also 4 Byte aus der Datei gelesen und dorthin geschrieben, wo ``size`` im Speicher liegt.

# 8

Mit ``seekg`` kann die Leseposition in der Datei geändert werden.

Die Parameter sind:

1. Offset, abhängig vom zweiten Parameter
2. Optionen:
   - ``std::ios_base::beg``: Gehe zum Dateianfang und überspringe dann _Offset_ Bytes.
   - ``std::ios_base::cur``: Überspringe von der aktuellen Stelle aus _Offset_ Bytes.
   - ``std::ios_base::end``: Gehe zum Dateiende und überspringe dann _Offset_ Bytes (_Offset_ ergibt hier nur Sinn, wenn es ``0`` oder negativ ist).

In diesem konkreten Fall werden also 8 Byte übersprungen, dies entspricht _(reserviert)_ bei Offset ``06h`` und _Offset, wo Pixeldaten anfangen_ bei Offset ``0Ah``.

Im Anschluss ist die Leseposition also bei _Größe der nachfolgenden Struktur in Byte_ (Offset ``0Eh``).

# 9

Jetzt lesen wir diese Größeninformation, genau schon wie die Dateigröße, in eine Variable.

# 10

Laut Standard muss diese Größe ``40`` sein. Daher brechen wir hier ebenfalls das Programm ab, wenn dies nicht der Fall ist.

# 11

Jetzt lesen wir noch Breite und Höhe des Bildes in Variablen…

# 12

… und geben dann noch alles auf der Konsole aus.
