#pragma once

/**
 * Beschreibt einen Punkt mit X- und Y-Koordinate
 */
class Point {
public:
    /**
     * Erzeugt einen neuen Punkt im Koordinatenursprung
     */
    Point();

    /**
     * Erzeugt einen neuen Punkt bei den übergebenen Koordinaten
     *
     * @param x X-Koordinate
     * @param y Y-Koordinate
     */
    Point(double x, double y);

    /**
     * Verschiebt den Punkt relativ um den Wert eines anderes Punktes
     *
     * @param other_p Anderer Punkt
     */
    void move_by(const Point& other_p);

    void move_by(double other_x, double other_y);

    /** X-Koordinate */
    double x = 0.0;

    /** Y-Koordinate */
    double y = 0.0;
};
