# 0

Hier möchte ich zeigen, wie man Getter und Setter implementiert.

Mit Gettern und Settern kann man den Zugriff auf Felder kapseln.

Dies ist insbesondere praktisch, wenn man ein Feld nur lesbar haben möchte. In diesem Fall implementiert man nur einen Getter.

Eine andere Möglichkeit ist die Fehlerprüfung, also das Ablehnen von ungültigen Daten. Dies ist in Storyteller 5 erklärt.

# 1

Zuerst machen wir alle Felder ``private``.

Ab jetzt kann nur noch innerhalb der Klasse ``Point`` auf diese zugegriffen werden.

# 2

Dies sind nun die Definitionen für die Getter und Setter für ``x`` und ``y``.

Getter akzeptieren keinen Parameter und haben als Rückgabewert den Typ des Feldes, dass Sie zurückgeben.

Setter akzeptieren eine Variable vom Typ des Feldes als Parameter und geben nichts (``void``) zurück.

Getter und Setter sind also denkbar einfach. Eine Kleinigkeit fehlt aber noch.

# 3

Was noch fehlt ist das ``const`` hinter den Gettern.

``const`` hiner der Parameterliste ist nur in Klassen zulässig. Freistehende Funktionen (die keiner Klasse angehören), können kein ``const`` an dieser Stelle stehen haben.

Das ``const`` bedeutet hier, dass diese Methode keine Felder der Klasse modifizieren darf.

Die Methode ``get_x`` kann nun auch von Objekten vom Typ ``const Point&`` aufgerufen werden. ``set_x`` hingegeben nicht, da diese nicht konstant ist.

# 4

Hier noch die Implementierungen der Getter und Setter.

Zu beachten ist, dass hier auch das ``const`` mit angegeben werden muss.

# 5

Um ganz korrekt zu sein, können wir nun auch noch ``print`` mit ``const`` versehen.

Diese Methode modifiziert schließlich auch das Objekt nicht.

# 6

Und auch hier die Änderung nicht vergessen.

# 7

Natürlich müssen jetzt auch die direkten Aufrufe der Felder auf Getter und Setter umgeändert werden.

Syntaktisch ist dies deutlich hässlicher, als die Variante mit ``public``. Die Vorzüge, werden in einem späteren Storyteller gezeigt.

# 8

Das hier ist bekannt: ``q`` ist nun eine konstante Referenz auf ``p``.

# 9

Da ``q`` konstant ist, kann dieser Setter nicht aufgerufen werden.

``set_y`` hat nicht den Vermerk ``const`` hinter der Parameterliste.

# 10

Anders verhält es sich aber bei ``print``. Diese Methode ist als ``const`` markiert und daher kann diese von ``q`` aufgerufen werden.
