# 0

Nun werden wir unseren Kreis um Exceptions erweitern.

Das Ziel ist ungültige Radien (``radius``) zu erkennen.

Wir wollen nur noch Radien akzeptieren, die größer als ``0`` sind.

# 1

Felder haben leider einen riesigen Nachteil: Es ist keine Fehlerüberprüfung möglich.

Diese fehlerhafte Zuweisung können wir nicht verhindern.

Dies können nur Methoden. Wenn eine Fehlerüberprüfung essenziell ist, muss also auf Getter und Setter zurückgegriffen werden.

# 2

Selbiges gilt hier: Also prinzipiell könnte der Code zwar prüfen, ob die Nutzereingabe positiv war, aber dies würde bedeuten, dass wir die Verantwortlichkeit auf den aufrufenden abwälzen.

Diese Prüfung muss die Klasse übernehmen.

# 3

Da wir eine Fehlerüberprüfung benötigen, müssen wir auf Getter und Setter zurückgreifen.

Der erste Schritt ist, den ``radius`` ``private`` zu machen.

# 4

Jetzt wie bekannt erstmal die Definition der Getter/Setter …

# 5

… und deren Implementierung (alles bereits bekannt).

# 6

Zusätzlich korrigieren wir noch in der ``main`` den Zugriff, damit der Code noch kompiliert.

# 7

Um Ausnahmen erzeugen zu können, benötigen wir den Header ``<stdexcept>``.

# 8

Dann prüfen wir im Setter einfach, ob der Radius kleiner oder gleich ``0`` ist und werfen in diesem Fall eine Exception.

Als unsere übliche Exception einigen wir uns auf ``std::runtime_error``.

Es ist guter Stil, eigene Exception-Klassen zu definieren und dann diese zu werfen, aber der Einfachheit halber werden wir immer ``std::runtime_error`` werfen.

Die Zeichenkette ist der Fehlertext, der mit ``e.what()`` abgefragt werden kann.

Ein ``throw`` ist ähnlich einem ``return``, aber es wird ein geeigneter ``catch``-Block gesucht.

Wenn es keinen gibt, wird das Programm beendet.

# 9

Hier im Konstruktor kann aber weiterhin jeglicher Radius zugewiesen werden.

# 10

Um dies zu lösen, rufen wir einfach unseren Setter auf. Dann wird im Konstruktor eine Exception erzeugt und ein passender ``catch``-Block gesucht.

# 11

Dieser Aufruf erzeugt nun eine Exception und lässt das Programm abstürzen.

# 12

Und hier wird ``Oh oh!`` ausgegeben, wenn der übergebene Radius ungültig ist.
