# 0

Abschließend behandeln wir noch Vererbung.

Vererbung bedeutet, dass Klassen die Felder und Methoden der Eltern-Klasse erben und auch überladen können.

Dazu werden wir mehrere tierische Klassen voneinander erben lassen und deren Laute ausgeben.

Die Eltern-Klasse ist ``Animal``.

# 1

Für das Beispiel definieren wir nur eine einzige Methode, die dann den konkreten Laut auf der Konsole ausgeben soll.

Kind-Klassen (erbende Klassen) von ``Animal`` sollen diese Methode _überladen_ und eine eigene Implementierung dieser bereitstellen.

# 2

``virtual`` bedeutet, dass diese Methode von Kind-Klassen überladen werden kann.

Wenn man ``virtual`` vergisst, funktioniert das Überladen von Methoden nicht korrekt.

# 3

``= 0`` bedeutet, dass diese Methode _abstrakt_ bzw. _pure virtual_ ist.

Klassen mit abstrakten Methoden können nicht instantiiert werden und Kind-Klassen werden gezwungen, diese Methode zu implementieren.

# 4

Zuerst definieren wir eine Klasse ``Duck``. In einer Datei können mehrere Klassen definiert werden. Wenn diese sehr kurz sind, ist dies eventuell übersichtlicher, als viele kleine Dateien zu erzeugen.

``Duck`` erbt von ``Animal``. Dies schreibt man so.

Auf keinen Fall das ``public`` hier vergessen, sonst funktioniert es nicht richtig.

# 5

``override`` bedeutet, dass diese Methode eine Methode der Eltern-Klasse überlädt.

# 6

Die Implementierung ist dann ganz einfach: Es wird der Tierlaut ausgegeben.

``Animal::Sound()`` wurde übrigens nicht implementiert, da die Methode _abstrakt_ ist.

# 7

Jetzt wurden hier noch zwei weitere Klassen erzeugt:

- ``Dog`` erbt von ``Animal``
- ``Cat`` erbt von ``Dog`` (und damit auch wieder von ``Animal``)

Dies ist erlaubt und ``Cat`` kann nun auch den Laut vom ``Dog`` wieder überschreiben.

# 8

Wie hier zu sehen ist.

# 9

Drei Tiere reichen uns. Jetzt können wir es testen.

# 10

Hier werden drei Objekte vom konkreten Typ erzeugt.

# 11

Dies ist erlaubt: ``Cat`` erbt von ``Animal``.

# 12

Dies ist auch erlaubt: ``Cat`` erbt von ``Dog``.

Umgekehrt, also ``Cat& not_a_cat = dog`` wäre aber unzulässig, da in diese Richtung nicht geerbt wird.

Eine Kind-Klasse kann also immer an die Referenz einer Eltern-Klasse gebunden werden.

# 13

Hier wird nun ``Quack!`` ausgegeben.

# 14

## Was wird hier ausgegeben?

- ``Quack!``
* ``Wuff!``
- ``Miau!``
- ``Kikeriki!``

# 15

## Was wird hier ausgegeben?

- ``Quack!``
- ``Wuff!``
* ``Miau!``
- ``Kikeriki!``

# 16

Die Referenz _merkt_ sich, welche Kind-Klasse sie eigentlich ist.

Daher gibt dies auch ``Miau!`` aus.

# 17

## Was wird hier ausgegeben?

- ``Quack!``
- ``Wuff!``
* ``Miau!``
- ``Kikeriki!``

# 18

An diese Funktion kann alles übergeben werden, was vom Typ ``Animal`` oder Kind davon ist.

# 19

Diese drei Aufrufe funktionieren also auch wie erwartet und geben ``Quack!``, ``Wuff!`` und ``Miau!`` aus.
