# 0

Jetzt lernen wir, wie Objekte explizit auf dem _Heap_ erzeugt werden.

Dies erfolgt mit ``new`` und ``delete``. Diese Art von manueller Speicherverwaltung benötigen wir in modernem C++ eigentlich nicht mehr. Dennoch ist es wichtig, dass man es mal gesehen hat, da natürlich auch noch viel älterer Code existiert. Zudem gibt es noch Entwickler, die sich nicht regelmäßig weiterbilden und daher keine _modernen_ Funktionalitäten von 2011 verwenden.

Den Heap verwendet man immer, wenn das Objekt zu groß für den Stack ist oder das Objekt ständig zwischen Funktionen herumgereicht wird und daher die Speicherverwaltung über den Stack zu kompliziert wird.

Konkrete Beispiele dafür werden wir dann nächste Woche bei SDL2 sehen.

# 1

Zuerst definieren wir wieder ein Scope.

# 2

Dies ist ein _Pointer_ auf einen ``Point``.

Pointer sind von Iteratoren bekannt. Diese _zeigen auf_  ein Objekt von diesem Typ, indem diese sich die Speicheradresse merken.

Diese Anweisung fordert aber keinen Speicher an. Dies ist einfach ein Pointer, der vorerst ins Nichts zeigt (sogenannter _dangling pointer_).

# 3

Hier erzeugen wir mit ``new`` einen ``Point`` auf dem Heap.

``new`` gibt die Adresse des erzeugten Punktes zurück, daher muss diese in einem Pointer gespeichert werden.

# 4

Syntaktisch ändert sich wenig, außer das nun auf Felder und Methoden mit ``->`` zugegriffen werden muss. Der Pfeil _dereferenziert_ den Pointer.

# 5

Hier wird der Scope verlassen und der Pointer wird zerstört. Aber nur der Pointer, nicht der Speicher wo dieser hinzeigt!

Da es nun keinen Pointer mehr gibt, der auf den ``Point`` zeigt, haben wir ein Speicherleck (_Memory Leak_) erzeugt: Der ``Point`` belegt Arbeitsspeicher, kann aber nicht mehr gelöscht werden. Dies ist ein Programmierfehler!

Der Speicher wird erst freigegeben, wenn das Programm beendet wird.

# 6

Gelöscht wird mit dem Operator ``delete``.

``new`` muss also immer zusammen mit ``delete`` auftreten.
