# 0

C++ gibt uns bei der Speicherverwaltung keine Sicherheitsgarantien.

Es ist problemlos möglich, ungültige Pointer zu erzeugen oder ein Objekt mehrfach zu löschen.

# 1

Fangen wir wieder an, indem wir einen Pointer auf einen ``Point`` erzeugen.

# 2

Hier wird einfach die Adresse von ``p`` an ``q`` zugewiesen.

Zwei Pointer zeigen jetzt also auf die gleiche Adresse.

# 3

Mit ``*`` _dereferenzieren_ wir den Pointer und weisen diesen dann einer Referenz zu.

# 4

Nun wird der Speicher mit ``delete`` freigegeben und das Übel nimmt seinen Lauf.

# 5

Der Pointer ``q`` zeigt auf freigegebenen Speicher, wo vorher der Punkt lag. Dies ist verboten!

Es können mehrere Dinge passieren:

- Das Programm stürzt ab (Im Debug-Modus immer, im Release-Modus in der Regel nicht)
- Wenn es nicht abstürzt kann es funktionieren, ab und zu kommt aber Datenmüll zurück, da der Speicher vielleicht schon wieder anders vergeben wurde.

# 6

Selbiges gilt für die Referenz. Da die Referenz über einen Pointer erzeugt wurde, zeigt diese nun auch auf Datenmüll.

# 7

Hier wird der von ``q`` referenzierte, bereits gelöschte ``Point`` erneut gelöscht.

Dies nennt sich _double free_ und ist auch ein Programmierfehler. Das Objekt wird zweimal gelöscht. Dies wird in der Regel erkannt und das Programm stürzt ab.
