#include <iostream>
#include <memory>
#include "point.h"

int main() {
    auto p = std::make_shared<Point>(1, 2);

    auto q = p;
    std::cout << q->get_x() << "\n";

    ⁽std::weak_ptr<Point> r = p⁾;⁹
    std::cout << ⁽r.lock()⁾->get_x() << "\n";

    p.reset();¹⁰

    std::cout << q->get_x() << "\n";
    std::cout << r.lock()->get_x() << "\n";

    ⁽q.reset()⁾;¹¹

    ⁽auto r2 = r.lock();
    if (r2) {
        std::cout << r2->get_x() << "\n";
    }⁾¹²

    ⁽q.reset(new Point(3, 4))⁾;¹³


    ⁽return 0⁾;¹⁴
}
