# 0

In diesem Storyteller lernen wir, wie mit SDL2 einfache Komponenten auf dem Bildschirm dargestellt werden können.

# 1

Grafische Anwendungen bestehen fast immer aus einem Eventloop.

Dieser ist einfach eine Endlosschleife in dem auf Benutzereingaben reagiert wird und dann basierend auf dieser Eingaben das Ergebnis dargestellt wird.

Die Endlosschleife kann durch eine Benutzereingabe beendet werden. Dies ist beispielsweise das "X" in der oberen rechten Ecke.

# 2

Events sind Betriebssystem abhängig. SDL2 wandelt diese für uns aber um.

Um Events zu lesen, gibt es ``SDL_PollEvent``. Dies nimmt einen Pointer (Referenzen existieren in C nicht) auf ein ``SDL_Event`` und befüllt dieses. Der Rückgabewert ist ``1``, bis kein Event mehr gelesen wird.

# 3

Der Typ (``type``) bestimmt die Kategorie des Events.

``SDL_QUIT`` bedeutet _Programmende angefordert_. Hier sollten ungespeicherte Daten gesichert werden (sofern notwendig) und die Schleife verlassen werden.

# 4

Nachdem die Bedingungen abgearbeitet sind, kann gerendert werden.

In diesem einfachen Beispiel hat der Benutzer keinen Einfluss auf die Programmausführung.

Zuerst setzen wir mit ``SDL_SetRenderDrawColor`` die Zeichenfarbe aller nachfolgenden Befehle.

Bei allen diesen Befehlen ist immer der ``SDL_Renderer`` der erste Parameter.

Danach folgen hier die Farbkanäle im RGB-Farbraum: Rot, Grün, Blau und der letzte Parameter ist die Transparenz. Standardmäßig wird die Transparenz aber ignoriert (das Verhalten kann mit ``SDL_SetRenderDrawBlendMode`` geändert werden).

## Welche Farbe ist das?

- Schwarz
* Weiß
- Rot

# 5

Dies ist bereits vom vorherigen Storyteller bekannt: Die _Zeichenfläche_ (Backbuffer) wird nun komplett weiß übermalt.

In modernen Programmen wird eigentlich immer von Grund auf neu gezeichnet, da moderne Computer schnell genug sind und sich dies oft leichter programmieren lässt.

# 6

Nun wollen wir eine Linie malen. Damit man diese sieht, ändern wir zuerst die Farbe.

## Welche Farbe ist das?

- Schwarz
- Weiß
* Rot

# 7

Mit ``SDL_RenderDrawLine`` kann eine Linie gezeichnet werden.

Diese wird beschrieben durch Start- und Endkoordinaten (``(x1, y1)`` und ``(x2, y2)``).

Die dicke der Linie kann nicht konfiguriert werden. Diese ist immer ein Pixel.

Um dickere Linien zu malen, kann beispielsweise der Befehl mehrmals mit leichtem Versatz ausgeführt werden. SDL2 bietet nur das absolute Minimum an Funktionalität.

# 8

Und jetzt malen wir grün weiter.

# 9

Für Rechtecke bietet SDL2 die Struktur ``SDL_Rect``.

Dieses besteht aus: X, Y, Breite, Höhe

Die Rechtecke sind also immer achsenparallel, genau wie unsere ``Rectangle``.

# 10

Mit ``SDL_RenderFillRect`` wird nun das Rechteck gezeichnet.

# Welche Maße hat das Rechteck (Breite x Höhe)?

- 200×300
* 150×50
- 50×150
- 300×200

# 11

Alle diese Zeichenoperationen sind im Backbuffer gelandet.

Damit diese sichtbar werden, rufen wir nun noch abschließend ``SDL_RenderPresent`` auf.

Die Reihenfolge ist also immer:

1. Auf Events reagieren
2. Hintergrundfarbe setzen
3. ``SDL_RenderClear`` aufrufen
4. Programmspezifische Dinge zeichnen
5. ``SDL_RenderPresent`` aufrufen
6. Von vorne anfangen
