# 0

In diesem Storyteller lernen wir die Programmierung des Arduino kennen.

Der Ansatz wird aber ziemlich High Level sein. Also wir werden nicht direkt die Hardware programmieren, indem wir beispielsweise irgendwelche Register setzen.

Stattdessen werden wir die Arduino-Bibliothek und C++ verwenden, wodurch vieles bereits gut abstrahiert wird.

Zudem wird in den Storytellern nicht über die Verkabelung gesprochen. Diese sollte seit den Praktika klar sein.

# 1

Für die Programmierung auf dem Arduino benötigen wir einen plattformspezifischen Header namens ``Arduino.h``.

In diesem sind alle Zusatzfunktionen des Arduino enthalten.

# 2

Für den Arduino existiert zwar ein C++-Compiler, aber keine C++ Standardbibliothek, d. h. Sprachkonstrukte wie foreach-Schleifen und Klassen können zwar verwendet werden, aber nichts, was von einem Header abhängt wie beispielsweise ``std::string`` oder ``std::vector``.

Praktischerweise gibt es aber (eingeschränkte) Portierungen der C++-Header von anderen Entwicklern. Über den Header ``ArduinoSTL.h`` kann auf diese zugegriffen werden.

Dieser Header zieht bereits alles rein. Zusätzliche includes für ``<vector>`` usw. sind unnötig.

# 3

Hier sehen wir direkt einen weiteren Unterschied:

Es existiert keine ``main``-Funktion. Eigentlich existiert diese schon, diese ist aber fest vorgegeben und kann von uns nicht überschrieben werden.

Stattdessen gibt es zwei neue Funktionen: ``setup()`` und ``loop()``.

``setup()`` wird einmalig beim Start aufgerufen. Hier kann also alles initialisiert werden.

# 4

``loop()`` wird in einer Endlosschleife aufgerufen.

Würden wir das mit einer ``main`` nachbauen, sähe es ungefähr so hier aus:

```cpp
int main() {
    setup();

    for (;;) {
        loop();
    }
}
```

# 5

Nun wollen wir beispielhaft eine LED ansteuern.

Dafür legen wir zuerst eine Variable fest, die den Pin enthält.

Das ``const`` verhindert, dass die Variable neu gesetzt werden kann.

# 6

Mit ``pinMode`` kann ein Pin (erster Parameter) auf dem Arduino für Eingabe (``INPUT``) oder Ausgabe (``OUTPUT``) konfiguriert werden.

Da an dem Pin eine LED hängt, konfigurieren wir hier eine Ausgabe.

Dieser Code steht in ``setup()``, da dies einmalige Initialisierung ist.

# 7

Mit ``digitalWrite`` können wir nun die LED an- oder ausschalten.

``HIGH`` steht für _an_ und ``LOW`` für aus.

Digital steht hier also für die binären Zustände 0 und 1.

Für mehr Flexibilität (dimmen von LEDs) kann ``analogWrite`` verwendet werden.

# 8

Mit ``delay`` wird das Programm für die übergebene Menge an Millisekunden (hier: 1 Sekunde) angehalten.

Dieser Mechanismus ist also ungeeignet, wenn noch nebenbei auf andere Dinge reagiert werden muss. Wie das besser geht, behandeln wir in einem späteren Storyteller.

# 9

Diese Anweisung schaltet die LED aus.

# 10

Jetzt warten wir noch eine weitere Sekunde und dann geht es wieder von vorne los.

Wir haben hier also eine blinkende LED erzeugt (jeweils eine Sekunde an und aus).
