#include "led.h"

#include <Arduino.h>

Led::Led() {
    // no-op
}

Led::Led(int port) {
    pinMode(port, OUTPUT);
    this->port = port;
}

unsigned char Led::get_brightness() const {
    return brightness;
}

void Led::set_brightness(unsigned char brightness_) {
    brightness = brightness_;
    on();
}

bool Led::is_on() const {
    return led_on;
}

bool Led::is_off() const {
    return !led_on;
}

void Led::on() {
    led_on = true;
    analogWrite(port, brightness);
}

void Led::off() {
    led_on = false;
    analogWrite(port, 0);
}

void Led::toggle() {
    if (is_on()) {
        off();
    } else {
        on();
    }
}

void Led::pulse() {
    ++brightness;
    on();
}
