#include <Arduino.h>
#include <ArduinoSTL.h>

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#include "button.h"
#include "led.h"

/** Hier können globale Variablen definiert werden. */
const int width = 128;
const int height = 64;
Adafruit_SSD1306 display(width, height);

Led led;
Button button;

int counter = 0;

/** Wird nach der Hardware-Initialisierung einmalig aufgerufen */
void setup() {
    // Konsolenausgabe aktivieren
    Serial.begin(9600);

    // Hardware konfigurieren
    led = Led(3);
    button = Button(4);

    // Display initialisieren
    if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
        std::cout << "SSD1306 fehler!\n";
    }

    delay(1000);

    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.print("Hallo Welt!");
    display.display();

    delay(1000)
}

/** Wird in einer Endlosschleife aufgerufen */
void loop() {
    display.clearDisplay();

    button.update();

    display.drawCircle(10, counter, 5, WHITE);

    display.fillRect(counter, 50, 20, 30, WHITE);

    display.display();

    ++counter;

    if (counter > 50) {
        counter = 0;
    }
}
