function fetchJSONFile(path, callback) {
    var httpRequest = new XMLHttpRequest();
    httpRequest.onreadystatechange = function() {
        if (httpRequest.readyState === 4) {
            if (httpRequest.status === 200) {
                var data = JSON.parse(httpRequest.responseText);
                if (callback) callback(data);
            }
        }
    };
    httpRequest.open('GET', path);
    httpRequest.send();
}

async function loadPlaybackData() {
    //playbackData.comments = {"ev-0":[{"id":"commentId-0","displayCommentEvent":{"id":"ev-0","timestamp":1648214856844,"createdByDevGroupId":"devGroupId-1","eventSequenceNumber":0,"permanentRelevance":"never relevant","type":"CREATE DIRECTORY","directoryId":"dirId-0","directoryPath":"/","parentDirectoryId":null},"developerGroupId":"devGroupId-1","timestamp":1648214856844,"commentText":"Enter a playback description","selectedCodeBlocks":[],"imageURLs":[],"videoURLs":[],"audioURLs":[],"linesAbove":0,"linesBelow":0,"currentFilePath":"","viewableBlogText":"","commentTags":[],"questionCommentData":{"allAnswers":[],"correctAnswer":"","question":""}}]};
    playbackData.isEditable = false;
    playbackData.developers = {"devId-0":{"id":"devId-0","userName":"Storyteller System","email":"system@ourcodestories.com","avatarURL":"https://www.gravatar.com/avatar/5fcc05d044610e96c28c9bb4b7278935"},"devId-1":{"id":"devId-1","userName":"Anonymous Developer","email":"anon@ourcodestories.com","avatarURL":"https://www.gravatar.com/avatar/265e214b9c99f4d4f703c6feb9d8652f"},"devId-2":{"id":"devId-2","userName":"Gabriel Kind","email":"kind@hs-mittweida.de","avatarURL":"https://www.gravatar.com/avatar/ed7af7fa2b462458c9c83db1278b21d5"}};
    playbackData.developerGroups = {"devGroupId-0":{"id":"devGroupId-0","memberIds":["devId-0"]},"devGroupId-1":{"id":"devGroupId-1","memberIds":["devId-1"]},"devGroupId-2":{"id":"devGroupId-2","memberIds":["devId-2"]}};
    playbackData.playbackTitle = 'Playback';
    playbackData.branchId = 'kP7w7X';

    const name = new URLSearchParams(window.location.search).get("name");

    return new Promise(resolve => {
        fetchJSONFile(`playback/events_${name}.json`, function(data){
            playbackData.events = data["events"];
            playbackData.numEvents = playbackData.events.length;
            fetchJSONFile(`playback/comments_${name}.json`, function(data){
                playbackData.comments = data["comments"];
                resolve(playbackData);
            });
        });
    });
}
