#include <iostream>
#include <iomanip>

int main() {
	int a = 42;

    std::cout << "Wert von a: " << a << "\n";

    // Adresse von a (Wo a im Speicher liegt)
    // Achtung: Nicht mit Referenzen verwechseln (int&)
    std::cout << "Adresse von a: " << &a << "\n";

    // Adresse von a in einer Variable speichern (Pointer)
    int* a_ptr = &a;

    std::cout << "Wert von a_ptr: " << a_ptr << "\n";
    std::cout << "Adresse von a_ptr: " << &a_ptr << "\n";
    std::cout << "a_ptr dereferenziert: " << *a_ptr << "\n";

    // Null-Pointer: Zeigt auf 0h im Speicher (Zero-Page)
    // Zero-Page: Bei Lesen/Schreiben Absturz
    a_ptr = nullptr;

    std::cout << "Wert von a_ptr: " << a_ptr << "\n";
    std::cout << "Adresse von a_ptr: " << &a_ptr << "\n";
    std::cout << "a_ptr dereferenziert: " << *a_ptr << "\n";

	return 0;
}
