#include "sdl_helper.h"

#include <SDL_render.h>
#include <chrono>
#include <thread>

using namespace std::chrono_literals;

int main(int, char**) {
    SDL_Helper sdl_helper;

    SDL_Renderer* renderer = sdl_helper.get_renderer();

    // Zeichenfarbe auf weiß setzen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF);

    // Gesamtes Fenster weiß einfärben
    SDL_RenderClear(renderer);

    // Änderungen sichtbar machen
    SDL_RenderPresent(renderer);

    // Erste Linie
    SDL_SetRenderDrawColor(renderer, 0xFF, 0x00, 0x00, 0xFF);
    SDL_RenderDrawLine(renderer, 10, 10, 300, 200);
    SDL_RenderPresent(renderer);

    // Zweite Linie
    SDL_SetRenderDrawColor(renderer, 0x00, 0x00, 0xFF, 0xFF);
    SDL_RenderDrawLine(renderer, 10, 30, 200, 100);
    SDL_RenderPresent(renderer);

    // Erstes Rechteck
    SDL_SetRenderDrawColor(renderer, 0x00, 0xFF, 0x00, 0xFF);
    SDL_Rect rect = {10, 10, 150, 50};
    SDL_RenderFillRect(renderer, &rect);

    // Erste Kreis
    // Pech gehabt. SDL2 hat keine eingebaute Funktion für Kreise :(

    for (;;) {
        SDL_Event evt;
        while (SDL_PollEvent(&evt)) {
            if (evt.type == SDL_QUIT) {
                // Benutzer hat Programmende angefordert (Fenster geschlossen)
                return 0;
            }
        }

        SDL_RenderPresent(renderer);
    }

    return 0;
}
