#include "sdl_helper.h"

#include <chrono>
#include <thread>

using namespace std::chrono_literals;

int main(int, char**) {
    SDL_Helper sdl_helper;

    SDL_Renderer* renderer = sdl_helper.get_renderer();

    // Zeichenfarbe auf weiß setzen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF);

    // Gesamtes Fenster weiß einfärben
    SDL_RenderClear(renderer);

    // Änderungen sichtbar machen
    SDL_RenderPresent(renderer);

    // Zeichenfarbe auf rot setzen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0x00, 0x00, 0xFF);

    for (int y = 0; y < 50; ++y) {
        for (int x = 0; x < 150; ++x) {
            SDL_RenderDrawPoint(renderer, 10 + x, 10 + y);
            SDL_RenderPresent(renderer);
            std::this_thread::sleep_for(100us);
        }
    }

    // Zeichenfarbe auf blau setzen
    SDL_SetRenderDrawColor(renderer, 0x00, 0x00, 0xFF, 0xFF);

    for (int x = 0; x < 100; ++x) {
        for (int y = 0; y < 200; ++y) {
            SDL_RenderDrawPoint(renderer, 100 + x, 30 + y);
            SDL_RenderPresent(renderer);
            std::this_thread::sleep_for(100us);
        }
    }

    for (;;) {
        SDL_Event evt;
        while (SDL_PollEvent(&evt)) {
            if (evt.type == SDL_QUIT) {
                // Benutzer hat Programmende angefordert (Fenster geschlossen)
                return 0;
            }
        }

        SDL_RenderPresent(renderer);
    }

    return 0;
}
