#include "sdl_helper.h"

#include <chrono>
#include <thread>

using namespace std::chrono_literals;

void bresenham_circle(SDL_Renderer* renderer, int xc, int yc, int r) {
    int x = 0;
    int y = r;
    double delta = 5.0 / 4.0 * r;

    while (y >= x) {
        SDL_RenderDrawPoint(renderer, xc+x, yc+y);
        //SDL_RenderDrawPoint(renderer, xc-x, yc+y);
        //SDL_RenderDrawPoint(renderer, xc+x, yc-y);
        //SDL_RenderDrawPoint(renderer, xc-x, yc-y);
        //SDL_RenderDrawPoint(renderer, xc+y, yc+x);
        //SDL_RenderDrawPoint(renderer, xc-y, yc+x);
        //SDL_RenderDrawPoint(renderer, xc+y, yc-x);
        //SDL_RenderDrawPoint(renderer, xc-y, yc-x);
        SDL_RenderPresent(renderer);

        std::this_thread::sleep_for(50ms);

        if (delta < 0) {
            delta += 2 * x + 3.0;
            ++x;
        } else {
            delta += 2 * x - 2 * y + 5.0;
            ++x;
            --y;
        }
    }
}

int main(int, char**) {
    SDL_Helper sdl_helper;

    SDL_Renderer* renderer = sdl_helper.get_renderer();

    // Zeichenfarbe auf weiß setzen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF);

    // Gesamtes Fenster weiß einfärben
    SDL_RenderClear(renderer);

    // Änderungen sichtbar machen
    SDL_RenderPresent(renderer);

    // Zeichenfarbe auf rot setzen
    SDL_SetRenderDrawColor(renderer, 0xFF, 0x00, 0x00, 0xFF);

    bresenham_circle(renderer, 100, 100, 50);

    // Zeichenfarbe auf blau setzen
    SDL_SetRenderDrawColor(renderer, 0x00, 0x00, 0xFF, 0xFF);

    bresenham_circle(renderer, 200, 130, 100);

    for (;;) {
        SDL_Event evt;
        while (SDL_PollEvent(&evt)) {
            if (evt.type == SDL_QUIT) {
                // Benutzer hat Programmende angefordert (Fenster geschlossen)
                return 0;
            }
        }

        SDL_RenderPresent(renderer);
    }

    return 0;
}
