#include "heart.h"
#include "point.h"

static constexpr int px[20] = {2, 3, 5, 6, 1, 4, 7, 0, 8, 0, 8, 0, 8, 1, 7, 2, 6, 3, 5, 4};
static constexpr int py[20] = {0, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8};

static constexpr int px_big[] = {2, 3, 4, 8, 9, 10, 1, 5, 7, 11, 0, 6, 12, 0, 12, 0, 12, 0, 12, 0, 12, 1, 11, 2, 10, 3, 9, 4, 8, 5, 7, 6};
static constexpr int py_big[] = {0, 0, 0, 0, 0, 0,  1, 1, 1, 1 , 2, 2, 2 , 3,  3, 4,  4, 5,  5, 6,  6, 7,  7, 8,  8, 9, 9, 10, 10, 11, 11, 12};

Heart::Heart() {
    position = Point(-1, -1);
}

Heart::Heart(Point top_left, int width) {
    position = top_left;
    if (width == 10) {
        width = 14;
    }
    this->width = width;
}

void Heart::draw(Adafruit_SSD1306& display) {
    if (width != 14)
        for (int i = 0; i < 20; ++i) {
          display.drawPixel(px[i] + position.x, py[i] + position.y, WHITE);
        }
    else
        for (int i = 0; i < 32; ++i) {
            display.drawPixel(px_big[i] + position.x, py_big[i] + position.y, WHITE);
        }
}
