#include <SDL.h>
#include <iostream>

#include "sdl_helper.h"

// WICHTIG:
// SDL2 unter Windows benoetigt unbedingt main(int, char**), sonst gibt es einen Fehler
// Die Variablennamen für die Parameter wurden weggelassen, sonst gibt es Compilerwarnungen
// (ungenutzter Parameter)
int main(int, char**) {
    // Hilfsklasse aufrufen, die für uns SDL initialisiert
    SDL_Helper sdl_helper;

    SDL_Renderer* renderer = sdl_helper.get_renderer();

    /* Game Loop */
    int x = 0;
    int y = 0;
    int width = 100;
    int height = 50;
    int xd = 1;
    int yd = 1;

    for (;;) {
        // Fenster schwarz ausmalen
        SDL_SetRenderDrawColor(renderer, 0x0, 0x0, 0x0, 0xFF);
        SDL_RenderClear(renderer);

        /* Eigener Code hier */
        SDL_Rect rect = { x, y, width, height };
        SDL_SetRenderDrawColor(renderer, 0xFF, 0x0, 0x0, 0xFF);
        SDL_RenderFillRect(renderer, &rect);

        if (x + width > sdl_helper.get_width() || x < 0) {
            xd = -xd;
        }

        if (y + height > sdl_helper.get_height() || y < 0) {
            yd = -yd;
        }

        // Aenderungen sichtbar machen
        SDL_RenderPresent(renderer);
    }

    return 0;
}
