#pragma once

#include <SDL.h>

#include "rectangle.h"

class Engine {
public:
    Engine(SDL_Renderer* renderer, int window_width, int window_height);

    /**
     * Reagiert auf Benutzerevents.
     * Bei Rückgabe von false wird das Programm beendet.
     */
    bool process_events();

    /**
     * Reagiert auf das Ergebnis der Eventverarbeitung und aktualisiert und zeichnet die Spiellogik.
     * In einem richtigen Spiel laufen Grafik und Logik unabhängig voneinander, aber so ist es einfacher.
     */
    void update_and_render();

private:
    SDL_Renderer* renderer;
    int window_width;
    int window_height;

    Rectangle rect;
};
