#include "circle.h"
#include "point.h"

Circle::Circle() {
    radius = 1.0;
    position = Point(-1, -1);
}

Circle::Circle(Point top_left, double radius) {
    this->position = top_left;
    set_radius(radius);
}

double Circle::get_radius() const {
    return radius;
}

void Circle::set_radius(double radius) {
    this->radius = radius;
}

double Circle::get_diameter() const {
    return 2 * radius;
}

Point Circle::get_center() const {
    Point mittelpunkt(
        position.x + radius,
        position.y + radius
    );

    return mittelpunkt;
}

bool Circle::is_inside(const Point& p) const {
    Point mittelpunkt = get_center();

    return (mittelpunkt.distance_to(p) < radius);
}

void Circle::draw(Adafruit_SSD1306& display) {
    display.drawCircle(
        position.x + get_radius(),
        position.y + get_radius(),
        get_radius(),
        WHITE);
}
