#pragma once

#include "circle.h"
#include "sprite.h"
#include "button.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    void draw(Adafruit_SSD1306& display) override;

    void update();

    void place_food();

    /** Anzahl Zellen je Zeile */
    const uint8_t field_width = 128 / 8;

    /** Anzahl Zellen je Spalte */
    const uint8_t field_height = 64 / 8;

    /** Breite und Höhe einer Zelle in Pixeln */
    const uint8_t rect_dim = 8;

    // Hoch, Runter, Rechts, Links
    const uint8_t up = 0;
    const uint8_t right = 1;
    const uint8_t down = 2;
    const uint8_t left = 3;

private:
    int tick = 0;
    double ticks_per_move = 20;

    std::vector<Point> snake;
    Point food;

    uint8_t direction = right;

    Button button_up;
    Button button_right;
    Button button_down;
    Button button_left;

    bool game_over = false;
    bool display_invert = false;
};
