#pragma once

#include "sprite.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    void draw(Adafruit_SSD1306& display) override;

    void update_field();

    /** Anzahl Zellen je Zeile */
    const uint8_t field_width = 128 / 4;

    /** Anzahl Zellen je Spalte */
    const uint8_t field_height = 64 / 4;

    /** Breite und Höhe einer Zelle in Pixeln */
    const uint8_t rect_dim = 4;

    const int up = 0;
    const int down = 1;
    const int left = 2;
    const int right = 3;

private:
    int direction = right;

    int tick = 0;
    double ticks_per_move = 10;
};
