#include "led.h"

#include <Arduino.h>

Led::Led() {
    // no-op
}

Led::Led(int port) {
    pinMode(port, OUTPUT);
    this->port = port;
}

unsigned char Led::get_brightness() const {
    return brightness;
}

void Led::set_brightness(unsigned char brightness_) {
    brightness = brightness_;
    on();
}

void Led::on() {
    analogWrite(port, brightness);
}

void Led::off() {
    analogWrite(port, 0);
}

void Led::pulse() {
    ++brightness;
    on();
}
