#pragma once

#include "sprite.h"
#include <vector>

class Board: public Sprite {
public:
    Board();

    void draw(SDL_Renderer* renderer) override;

    void update_field();

    void place_food();

    void set_direction(int new_direction);

    const int field_dim = 15;
    const int rect_dim = 48;

    // Bewegungsrichtungen
    const int up = 0;
    const int right = 1;
    const int left = 2;
    const int down = 3;

private:
    // Bewegungsrichtung der Schlange
    int direction = right;

    // Zähler (Wird jeden Frame erhöht (also 60x pro Sekunde))
    int tick = 0;

    // Schwellwert, wann die Schlange sich bewegen soll
    double ticks_per_move = 20;

    std::vector<Point> snake;
    Point food;

    bool game_over;
};
